/**
 * 开|转|理财户结果
 */
define("project/scripts/account/accountResult",function(require,exports,module){
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
	gconfig = require("gconfig"),
	layerUtils = require("layerUtils"),
	global = gconfig.global,
	service = require("serviceImp").getInstance(),  //业务层接口，请求数据
	_pageId = "#account_accountResult";
	
	/* 私有业务模块的全局变量 end */

	function init()
	{
		queryAccount(); // 查询用户信息
	}

	function bindPageEvent()
	{
		/* 确定 */
		appUtils.bindEvent($(_pageId+" .next"),function(){
			submitVisitQuestions();
		});
		
		
		appUtils.bindEvent($(_pageId+" .back"),function(){
			appUtils.pageInit("account/accountResult","account/signProtocol");
		});
		
		appUtils.bindEvent($(_pageId+" .icon_back"),function(){
			appUtils.pageInit("account/accountResult","account/riskAssessment");
		});
	}

	function submitVisitQuestions(){
	  	var param = {
	  			"user_id" : appUtils.getSStorageInfo("user_id"),
	  			"sub_id":'5060',
	  			"q_a_args":'1|1'
		};
	  	
		service.submitVisitAnswer(param,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			console.log("submitVisitAnswer error_no=" + error_no + " error_info=" + error_info);
			if(error_no == 0){
	  			//调用成功，调到下一个页面
				layerUtils.iAlert("您已成功提交开户申请！",0,redirecthtm0);
		  	} else if(error_no == 1) {
		  		layerUtils.iAlert(error_info,-1,redirecthtm1);
		  	} else if(error_no == 2) {
		  		layerUtils.iAlert(error_info,-1,redirecthtm2);
		  	} else if(error_no == -1 && error_info != null && error_info.indexOf("开户成功后，将会发送短信通知您") >= 0) {
		  		// 非交易时间开户成功
		  		layerUtils.iAlert(error_info,-1,redirecthtmsub1);
		  	} else{
		  		layerUtils.iAlert(error_info,-1, exitApp);
		  	}
		});
		
		
	}
	
	function exitApp() {
		require("utils").layerTwoButton("退出系统？","确认","取消",function(){
			require("shellPlugin").callShellMethod("closeAppPlugin",null,null);  // 退出程序
			},
			function(){return false;});
	}
	
	function redirecthtm0() {
		redirecthtm("0");
	}
	function redirecthtm1() {
		redirecthtm("1");
	}
	function redirecthtm2() {
		redirecthtm("2");
	}
	function redirecthtmsub1() {
		var qdId = "";
		if ("qdsw" == global.open_channel) {
			qdId = appUtils.getSStorageInfo("qdid");
		} else {
			qdId = global.open_channel;
		}

		if (qdId != null && qdId.length > 0) {
			var needAddPage = appUtils.getSStorageInfo("needAddPage");
			if (needAddPage == "1") {
				// 需要跳转宣传页面
				var url = appUtils.getSStorageInfo("jumpUrl");
				
				if (url != null && url.length > 3) {
					var mobileNo = appUtils.getSStorageInfo("mobileNo");
					require("shellPlugin").callShellMethod("webViewPlugin", null, null, {"url":url, "isShowTitle":false});
				} else {
					exitApp();
				}
			} else {
				var is_need_open_other_app = appUtils.getSStorageInfo("is_need_open_other_app");
				if (is_need_open_other_app != null && is_need_open_other_app != "undefined" && is_need_open_other_app == "1") {
					var jumpUrl = appUtils.getSStorageInfo("jumpUrl");
					var dialog_content = appUtils.getSStorageInfo("dialog_content");
					var reopen_url = appUtils.getSStorageInfo("reopen_url");
					
					if (jumpUrl != null && jumpUrl.length > 0) {
						if (dialog_content != null && dialog_content != "undefined" && dialog_content.length > 0) {
							require("utils").layerTwoButtonWithTitle("温馨提示", dialog_content,"取消","确认",function(){
								return false;
							}, function(){
								require("shellPlugin").callShellMethod("webViewPlugin", null, null, {"url":jumpUrl, "isShowTitle":false, "reopenUrl":reopen_url == "1"?true:false});
							});
						} else {
							require("shellPlugin").callShellMethod("webViewPlugin", null, null, {"url":jumpUrl, "isShowTitle":false, "reopenUrl":reopen_url == "1"?true:false});
						}
					} else {
						// 需要返回第三方APP，但是又没有设置跳转URL，这种情况认为需要关闭开户，返回第三方APP
						if (dialog_content != null && dialog_content != "undefined" && dialog_content.length > 0) {
							require("utils").layerTwoButtonWithTitle("温馨提示", dialog_content,"取消","确认",function(){
								return false;
							}, function(){
								require("shellPlugin").callShellMethod("closeAppPlugin",null,null);
							});
						} else {
							require("shellPlugin").callShellMethod("closeAppPlugin",null,null);
						}
					}
				} else {
					exitApp();
				}
			}
		} else {
			exitApp();
		}
	}

	function redirecthtm(step) {
		if(step == '0') {
			appUtils.setSStorageInfo("curstep","success");
			appUtils.pageInit("account/accountResult","account/accountResult2");
		} else if(step == '1') {
			appUtils.setSStorageInfo("curstep","success");
			appUtils.pageInit("account/accountResult","account/accountResult2");
		}  else if(step == '2') {
			appUtils.setSStorageInfo("curstep","success");
			appUtils.pageInit("account/accountResult","account/backSignProtocol");
		}
	}
	
	/* 查询用户信息 */
	function queryAccount()
	{
		var param = {"user_id" : appUtils.getSStorageInfo("user_id")};
		service.queryUserInfo(param, function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == 0)
			{
				var res = data.results[0];
				appUtils.setSStorageInfo("fund_account",res.fund_account);  // 资金账号
				appUtils.setSStorageInfo("shfund_select",res.shfund_select);  // 沪基金状态
				appUtils.setSStorageInfo("szfund_select",res.szfund_select); // 深基金状态 
				appUtils.setSStorageInfo("szaselect",res.szaselect); // 深A状态
				appUtils.setSStorageInfo("shaselect",res.shaselect); // 沪A状态
				appUtils.setSStorageInfo("szaaccount",res.szaaccount); // 深A账号
				appUtils.setSStorageInfo("shaaccount",res.shaaccount); // 沪A账号
				appUtils.setSStorageInfo("szfund_account",res.szfund_account); // 深基金账号
				appUtils.setSStorageInfo("shfund_account",res.shfund_account); //沪基金账号
				showOpenAccount();  // 显示开户结果
			}
			else
			{
				layerUtils.iMsg(-1, error_info);
			}
		});
		
		sendStatisticInfo();
	}
	
	function sendStatisticInfo() {
		var qdId = "";
		if ("qdsw" == global.open_channel) {
			qdId = appUtils.getSStorageInfo("qdid");
			if (qdId == null) {
				qdId = "";
			}
		} else {
			qdId = global.open_channel;
		}

		var versionName = "";
		require("shellPlugin").callShellMethod("getVersionPlugin", function(data) {
					versionName = data.versionName;
				});
		
		require("shellPlugin").callShellMethod("getOsVersionPlugin",function(data){
		     var parm = {
		        "userid":appUtils.getSStorageInfo("user_id"),
		         "user_step" :'open',
		         "open_channel" : qdId,
		         "open_source" :  require("gconfig").global.open_source,
		         "machine_mobile" :  data.mobileModel,
		         "machine_brand" :   data.mobileBrand,
		         "machine_os" :      data.mobileOs,
		         "kh_version" : versionName
	         };
	         service.logOperChannel(parm);
		});
	}

	/* 显示新开户结果 */
	function showOpenAccount()
	{
		// 从 session 中取资金账号和股东账号
		var shaselect = appUtils.getSStorageInfo("shaselect"),  // 是否选择沪A
		szaselect = appUtils.getSStorageInfo("szaselect"),  // 是否选择深A
		shfund_select = appUtils.getSStorageInfo("shfund_select"),  // 是否选择沪基金
		szfund_select = appUtils.getSStorageInfo("szfund_select"),  // 是否选择深基金
		fund_account = appUtils.getSStorageInfo("fund_account"),  // 资金账号
		shaaccount = appUtils.getSStorageInfo("shaaccount"), // 沪A股东账户
		szaaccount = appUtils.getSStorageInfo("szaaccount"),  // 深A股东账户
		shfund_account = appUtils.getSStorageInfo("shfund_account"),  // 沪基金账户
		szfund_account = appUtils.getSStorageInfo("szfund_account"),// 深基金账户
		branchno = appUtils.getSStorageInfo("branchno"); //营业部id

		//深A账户展示
		if(szaselect == null){
			$(_pageId+" #sa").html("未申请");
		}else if(szaaccount == null||szaaccount=="undefined"){
			$(_pageId+" #sa").html("新开");
		}else{
			$(_pageId+" #sa").html(szaaccount);
		}
		//沪A账户展示
		if(shaselect == null){
			$(_pageId+" #ha").html("未申请");
		}else if(shaaccount == null ||shaaccount=="undefined"){
			$(_pageId+" #ha").html("新开");
		}else{
			$(_pageId+" #ha").html(shaaccount);
		}
		$(_pageId+" #name").html(appUtils.getSStorageInfo("custname"));
		$(_pageId+" #idno").html(appUtils.getSStorageInfo("idCardNo"));
		
		//查询营业部名称
		if(branchno != "" && branchno!=null && branchno!=undefined){
			service.queryBranch({},function(data){
				var error_no = data.error_no;
				var error_info = data.error_info;
				if(error_no=="0"){
					var branchList = data.branchList;	//营业部集合
					var branchname = "未查出结果";
					if(branchList != null && branchList.length >0){
						for(var i=0;i<branchList.length;i++){
			 				if(branchList[i]["branchcode"] == branchno){
			 					branchname = branchList[i]["branchname"];
			 					appUtils.setSStorageInfo("branchname",branchname); //营业部名称			 				}
			 				}
						}
						
					}
					$(_pageId+" #branchname").html(branchname);
					openFinishQuery();
				}else{
					layerUtils.iMsg(-1, error_info);
				}
			});
			
		}
		
		
		
	}

	function openFinishQuery(){

		var openFinishResult = function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			var result = data.results;
			if(error_no == 0){
				if(result.length!=0){
					//页面展示
					$(_pageId+" #bank").html(result[0]["item_name"]);
					for(var i=0;i<result.length;i++){
						if(result[i]["sub_id"]=='1'){
							var str = result[i]["define_value"].trim();
							if(str =='1'){
								$(_pageId+" #fengxian").html("C1(不含风险承受能力最低类别的投资者)");
							}
							else if(str =='2'){								
								$(_pageId+" #fengxian").html("C2(中低风险承受能力)");
							}
							else if(str =='3'){								
								$(_pageId+" #fengxian").html("C3(中风险承受能力)");
							}
							else if(str =='4'){								
								$(_pageId+" #fengxian").html("C4(中高风险承受能力)");
							}
							else if(str =='5'){								
								$(_pageId+" #fengxian").html("C5(高风险承受能力)");
							}
						}else if(result[i]["sub_id"]=='15'){
							$(_pageId+" #fanxiqian").html(result[i]["define"]);
						}
					}
				}
				$(_pageId+" .order_succes .mt15").show();
			}else {
				layerUtils.iMsg(-1, error_info);
			}

		};
		var param = {"user_id" : appUtils.getSStorageInfo("user_id")};
		service.openFinishQuery(param, openFinishResult);


	}


	function destroy()
	{
		$(_pageId+" order_succes p:eq(3)").html("");
		$(_pageId+" #gdzh").html("");
//		appUtils.clearSStorage();  // 清空所有的session
	}

	var accountResult = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};

	/**
	 * 清除项目中的html
	 */
	/*$("#bodyContent .page").each(function(){
		$(this).remove();
	});*/


	module.exports = accountResult;
});