/**
 * 签署协议
 */
define("project/scripts/account/backSignProtocol",function(require, exports, module){ 
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
	    service = require("serviceImp").getInstance(),  //业务层接口，请求数据
		global = require("gconfig").global,
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		Map = require("map"),
		fristMap = null,  //  存放所有相关协议
	    protocolArray = new Array(),  // 存放协议签名值
		isClose = true,  // 用于控制等待层
		countProtocol = 0, // 计算签署成功的数量
		userId = appUtils.getSStorageInfo("user_id"),
	    cert_type = appUtils.getSStorageInfo("openChannel") == "new" ? "zd" : "tw", // tw:天威 zd:中登
	    _pageId = "#account_backSignProtocol";
	/* 私有业务模块的全局变量 end */
	
	function init()
	{
		initPage();  // 初始化页面
		//add by gell 2015年11月25日10:53:36 证书配置相关
		if(appUtils.getSStorageInfo("flag") == "1"){//1:需要证书  0：不需要证书
			checkCert();  //检测证书是否存在
		}else{
			getMarket();  // 显示证券账户和协议
		}
	}
	
	function bindPageEvent()
	{
		/* 隐藏按钮*/
		appUtils.bindEvent($(_pageId),function(e){
			$(_pageId+" .btn_bot").hide();
		});
		
		/* 绑定签署协议*/
		appUtils.bindEvent($(_pageId+" .rule_check .icon_check"),function(){
			$(this).toggleClass("checked"); //  切换勾选样式
		});
		
		/* 继续开户（下一步）*/
		appUtils.bindEvent($(_pageId+" .fix_bot .ct_btn a"),function(){
			//add by gell 2015年11月25日10:53:36 证书配置相关
			if(appUtils.getSStorageInfo("flag") == "1"){//1:需要证书  0：不需要证书
				getSignProtocl();  // 获取签名值并验签
			}else{
				//openZjAccountAndClient();	//开立账户系统客户号和资金账户 
				getNoSignProtocl();  // 获取签名值并验签
			}
		});
		
		/* 点击页面其他元素隐藏下拉列表 */
		appUtils.bindEvent($(_pageId),function(e){
			$(_pageId+" .sel_list").slideUp("fast");	// 隐藏下拉列表
			e.stopPropagation();	// 阻止冒泡
		});
		
	}
			
	function bindEvents(templateNum) {
		// if (templateNum != 1) {
			/* 绑定选择资产账户 */
			appUtils.bindEvent($(_pageId+" .sel_template"),function(e){
				$(_pageId+" .template ul li").removeClass("active");
				$(_pageId+" .template").slideToggle("fast");	// 显示选择营业厅的下拉列表
				e.stopPropagation();	// 阻止冒泡
			});
		// }
	}
	
	function destroy()
	{
		service.destroy();
	}
	
	/* 初始化页面 */
	function initPage()
	{
		layerUtils.iLoading(true);  // 开启等待层。。。
		isClose = true;
		if(appUtils.getSStorageInfo("openChannel") == "change")
		{
			if(appUtils.getSStorageInfo("finance") == "finance")
			{
				$(_pageId+" .fix_bot .ct_btn a").html("继续开户 >");  // 理财户
			}
			else
			{
				$(_pageId+" .fix_bot .ct_btn a").html("继续转户 >");  // 转户
			}
		}
		else
		{
			$(_pageId+" .fix_bot .ct_btn a").html("继续开户 >");  // 开户
		}
	}
	
	/* 检测是否安装证书 */
	function checkCert()
	{
		//本页面需要用到证书，如果进入本页面时，证书不存在就下载并安装证书
		var existsParam = {
			"userId" : userId,
			"mediaid" : "certificate",
			"type" : cert_type
		};
		require("shellPlugin").callShellMethod("fileIsExistsPlugin",function(data){
			// 如果未检测到本地有证书，就安装证书
			if(data.mediaId == "")
			{
				utils.installCertificate(getMarket);  // 下载安装证书，并且显示证券账户和协议
			}
			else
			{
				getMarket();  // 显示证券账户和协议

			}
		},function(){
			layerUtils.iLoading(false);  // 关闭等待层。。。
		},existsParam);
	}
	
	/* 获取市场列表 */
	function getMarket()
	{
		// 获取开通证券账户枚举
		var allOpenAccountStr = ""; 
		service.queryDataDict({"enum_type" : "zqzhlx"},function(data){
			if(data.error_no == 0 && data.results.length != 0)
			{
				var openAccountEnum = data.results;
				for(var i = 0;i<openAccountEnum.length;i++)
				{
					if("0178".indexOf(openAccountEnum[i].item_value)>-1){
						allOpenAccountStr += "<li><a href=\"javascript:;\" class=\"icon_radio\" id=\"selectAccount0"+i+
						"\" value=\""+openAccountEnum[i].item_value+"\">"+openAccountEnum[i].item_name+"</a></li>";
					}
				}
				$(_pageId+" .radio_list ul").html(allOpenAccountStr);  // 填充 开通证券账户
				initSelcet();  // 初始化证券账户的选择
				getOpenAccountTemplateNew();//获取资金模板
			}
			else
			{
				layerUtils.iLoading(false);  // 关闭等待层。。。
				layerUtils.iAlert(data.error_info);
			}
		},false,true,handleTimeout);
	}

	function getTemplateByQdId(qdId) {
		var parm = {
				"phone":appUtils.getSStorageInfo("mobileNo"),
				"operatetype" : "C",  // 根据手机号码获取渠道佣金模版
				"qd_bh" : qdId
			};
		
		service.queryChannelInfoNewByChannel(parm,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no=="0"){
				var results = data.results;
				var len = results.length;
				if(len > 0){
					var branchno = appUtils.getSStorageInfo("branchno"); 
					
					// if (len == 1) {
					// 	// 只有一个模版
					// 	var branchId = results[0].yyb_dm.trim(); // 营业部编号
					// 	var branchName = results[0].yyb_name.trim(); // 营业部名称
					// 	var templateid = results[0].cm_dm.trim(); // 佣金编号
					// 	var templatename = results[0].cm_name.trim(); // 佣金名称
					// 	if (branchno == branchId) {
					// 		$(_pageId+" .sel_template").removeClass("sel_text").addClass("sel_text_fixed");
					// 		$(_pageId+" .sel_template").attr("templateid", templateid);
					// 		$(_pageId+" .sel_template").text(templatename);
					// 		$(_pageId+" .sel_template").unbind();
							
					// 		appUtils.setSStorageInfo("templateName",templatename);
					// 	} else {
					// 		layerUtils.iMsg(-1,"您选择的营业部没有匹配的资产模版");
					// 	}
					// } else {
						var template_str = "";
						var isValid = false;
						var validLen = 0;
						for (var i = 0; i < len; i++) {
							var branchId = results[i].yyb_dm.trim(); // 营业部编号
							var branchName = results[i].yyb_name.trim(); // 营业部名称
							var templateid = results[i].cm_dm.trim(); // 佣金编号
							var templatename = results[i].cm_name.trim(); // 佣金名称
							if (branchno == branchId) {
								validLen++;
								template_str+= "<li templateid='"+templateid+"'><span>"+templatename+"</span></li>";
								isValid = true;
							}
						}
						bindEvents(validLen);
						$(_pageId+" .template ul").html(template_str);  
						bindTemplate();//绑定资金账户事件
						layerUtils.iLoading(false);
						if (!isValid) {
							layerUtils.iMsg(-1,"您选择的营业部没有匹配的资产模版");
						}
					// }
				} else {
					bindEvents(0);
					getOpenAccountTemplate();
				}
			} else {
				bindEvents(0);
				layerUtils.iLoading(false);  // 关闭等待层。。。
				layerUtils.iAlert(error_info);
			}
		},false,true,handleTimeout);
	}

	function getOpenAccountTemplateNew() {
		var qdId = "";
		if ("qdsw" == global.open_channel) {
			qdId = appUtils.getSStorageInfo("qdid");
		} else {
			qdId = global.open_channel;
		}
		
		if (qdId != null && qdId.length > 0) {
			var recommendno = appUtils.getSStorageInfo("recommendno");
			var branchno = appUtils.getSStorageInfo("branchno");
			var branchname = appUtils.getSStorageInfo("branchname");
			console.log("getOpenAccountTemplateNew recommendno=" + recommendno);
			// if (recommendno != null && recommendno.length > 0) {
			// 	// 走过标准包或银行渠道包流程，已选择推荐人
			// 	goonOpenTip(branchname);
			// } else {
				var isGoonOpen = appUtils.getPageParam("goonopen");
				if (!isGoonOpen) {
					getTemplateByQdId(qdId);
				} else {
					var parm = {
							"phone":appUtils.getSStorageInfo("mobileNo"),
							"operatetype" : "A",  // 根据手机号码获取渠道营业部
							"qd_bh" : qdId
					};
					
					service.queryChannelInfoNewByChannel(parm,function(data){
						var error_no = data.error_no;
						var error_info = data.error_info;
						if(error_no=="0"){
							var results = data.results;
							var len = results.length;
							if(len > 0){
								var isValid = false;
								
								// 获取当前所有可选营业部ID，名称
								for (var i = 0; i < len; i++) {
									var branchId = results[i].yyb_dm.trim(); // 营业部编号
									var branchName = results[i].yyb_name.trim(); // 营业部名称
									if (branchno == branchId) {
										isValid = true;
										break;
									}
								}
								
								if (isValid) {
									getTemplateByQdId(qdId);
								} else {
									goonOpenTip(branchname);
								}	
							} else {
								// 没有配置营业部，走标准流程
								bindEvents(0);
								getOpenAccountTemplate();
							}
						} else {
							bindEvents(0);
							layerUtils.iLoading(false);
							layerUtils.iMsg(-1,"佣金模版获取失败");
						}
					},true,true,handleTimeout);
				}
			// }
			
		} else {
			bindEvents(0);
			getOpenAccountTemplate();
		}
	}
	
	function goonOpenTip(branchname) {
		utils.layerTwoButton("您已选择" + branchname + "作为您的开户营业部，请确认是否继续开户？","确认","取消",function(){
			bindEvents(0);
			getOpenAccountTemplate();
		},
		function(){
			require("shellPlugin").callShellMethod("closeAppPlugin",null,null);  // 退出程序
		});
	}

	//获取资金模板
	function getOpenAccountTemplate(){
		var param = {
				"user_id" : appUtils.getSStorageInfo("user_id")
		};
		
		//获取资金模板
		service.openAccountTemplate(param,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			// 调接口成功，选中开过的证券账户
			if(error_no == 0 && data.results){
				var account =  data.results;
				if(account!=null&&account.length>0){
					var template_str = "";
					for(var i=0; i<account.length; i++)
					{
						template_str+= "<li templateid='"+account[i].id+"'><span>"+account[i].name+"</span></li>";
					}
					$(_pageId+" .template ul").html(template_str);  
					bindTemplate();//绑定资金账户事件
				}
				layerUtils.iLoading(false);
			}else
			{
				layerUtils.iLoading(false);  // 关闭等待层。。。
				layerUtils.iAlert(error_info);
			}
		},false,true,handleTimeout);
	}
	
	//绑定资金账户事件
	function bindTemplate(){
		appUtils.bindEvent($(_pageId+" .template ul li"),function(e){
			var templateid = $(this).attr("templateid");
			$(this).addClass("active").siblings().removeClass("active");
			var templateName = $(this).text();  //当前选中的佣金值
			$(_pageId+" .sel_template").attr("templateid",templateid);	 
			$(_pageId+" .sel_template").text(templateName);	  //选中值赋给选择框
			appUtils.setSStorageInfo("templateName",templateName);
			$(_pageId+" .template").slideUp("fast");	//隐藏下拉框
			e.stopPropagation();	// 阻止冒泡
		});
	}
	
	/* 默认所有的账号都开通 */
	function initSelcet()
	{
		// 删除深B、沪B
		$(_pageId+" .radio_list ul li a[value='2']").parent().remove();  
		$(_pageId+" .radio_list ul li a[value='4']").parent().remove();
		// 账号绑定提醒事件，数据填充完毕才绑定事件
		appUtils.bindEvent($(_pageId+" .radio_list ul li a"),function(e){
			confrimOpenAccount($(this));
			e.stopPropagation();
		});
		// 新开户默认开所有的股东账户
		if(appUtils.getSStorageInfo("openChannel") == "new")
		{
			$(_pageId+" .radio_list ul li a").addClass("checked");
			getAgreement();  // 获取协议
		}
		// 转户需要查询原有的股东账户
		else if(appUtils.getSStorageInfo("openChannel") == "change")
		{
			// 转户删除基金
			$(_pageId+" .radio_list ul li a[value='5']").parent().remove();  
			$(_pageId+" .radio_list ul li a[value='6']").parent().remove();
			// 转户选中查询出来的证券账户
			var lookAccountParam = {"user_id" : appUtils.getSStorageInfo("user_id")};
			service.queryUserInfoExistCompy(lookAccountParam,function(data){
				var error_no = data.error_no;
				var error_info = data.error_info;
				// 调接口成功，选中开过的证券账户
			    if(error_no == 0 && data.result)
				{
					// stkbd 交易板块 0 深A；1 沪A；4 深基金；5  沪基金
					for(var i=0,len=data.results.length;i<len;i++)
					{
						switch(Number(data.results[i].stkbd))
						{
							case 0 :   // 深 A
								$(_pageId+" .radio_list ul li a[value='1']").addClass("checked");
								$(_pageId+" .radio_list ul li a[value='1']").attr("trdacct",data.results[i].trdacct);
								break;
	 						case 1 :   // 沪 A
								$(_pageId+" .radio_list ul li a[value='3']").addClass("checked");
								$(_pageId+" .radio_list ul li a[value='3']").attr("trdacct",data.results[i].trdacct);
								break;
						}
					}
				}
				else
				{
					layerUtils.iLoading(false);  // 关闭等待层。。。
 					$(_pageId+" .radio_list ul li a").addClass("checked");  //接口调用失败，则全选
				}
				getAgreement();  // 获取协议
			},false,true,handleTimeout);
		}
	}
	
	/* 获取协议 */
	function getAgreement()
	{
		// category_no 1.资金开户协议   2.证券账户开户协议
		service.queryProtocolList({"category_no":"1"},function(data){
			if(data.error_no == 0 && data.results.length != 0)
			{
				fristMap = new Map();
				var results = data.results,
					  allProtocols = "";
				var protocolMap = null;
				for(var i=0;i<results.length;i++)
				{
					protocolMap = new Map();
					protocolMap.put("protocolid",results[i].econtract_no);	//协议id
					protocolMap.put("protocolname",results[i].econtract_name);	//协议名
					protocolMap.put("summary",results[i].econtract_md5);	//协议内容MD5,签名摘要信息
					allProtocols += "<li><a href=\"javascript:;\" protocol-id=\""+results[i].econtract_no+"\" id=\"protocol0"+i+"\">《"+
						results[i].econtract_name+"》</a></li>";
					// 预绑定查看协议的事件
					appUtils.preBindEvent($(_pageId+" .rule_list ul"),"#protocol0"+i,function(e){
						appUtils.pageInit("account/signProtocol","account/showProtocol",{"protocol_id" : $(this).attr("protocol-id")});
						e.stopPropagation();
					});
					fristMap.put(i,protocolMap);
				}
				$(_pageId+" .rule_list ul").html(allProtocols);
			}
			else
			{
				layerUtils.iLoading(false);  // 关闭等待层。。。
				layerUtils.iAlert(data.error_info);
			}
		},true,true,handleTimeout);
	}
	
	/* 处理请求超时 */
	function handleTimeout()
	{
		layerUtils.iLoading(false);
		layerUtils.iConfirm("请求超时，是否重新加载？",function(){
			layerUtils.iLoading(true);
			getMarket();  // 再次获取市场代码和协议
		});
	}
	
	/* 提示用户若不开通某账号将影响正常交易 */
	function confrimOpenAccount(obj)
	{
		if($(obj).hasClass("checked"))
		{
			var accountName = $(obj).html();
			$(_pageId+" .btn_bot h5").html("确定取消开立\""+accountName+"\"账户？");
			if($(obj).attr("value")=="0"){
				//取消深A提示
				$(_pageId+" .btn_bot p").html("温馨提示，取消开立“深圳A股账户”后您将无法参与深交所股票、基金等交易，是否确定？");
			}else if($(obj).attr("value")=="1"){
				$(_pageId+" .btn_bot p").html("温馨提示，取消开立“上海A股账户”后您将无法参与上交所股票、基金等交易，是否确定？");
			}else{
				$(_pageId+" .btn_bot p").html("不开通\""+accountName+"\"账户，将影响您该项正常交易<br>请您慎重选择");
			}
			$(_pageId+" .btn_bot").show()
			// 确定取消
			appUtils.bindEvent($(_pageId+" .btn_box a:eq(0)"),function(e){
				$(obj).removeClass("checked");
				$(_pageId+" .btn_bot").hide();
				e.stopPropagation();
			});
			// 继续开立
			appUtils.bindEvent($(_pageId+" .btn_box a:eq(1)"),function(e){
				$(_pageId+" .btn_bot").hide();
				e.stopPropagation();
			});
		}
		else
		{
			$(obj).addClass("checked");  // 选中当前开通账户
		}
	}
	
	/* 获取签名值 */
	function getSignProtocl()
	{
		var keys = fristMap.keys();  // 协议的数量
		// 检查是否勾选开通的账户
		if(!$(_pageId+" .radio_list a").hasClass("checked")){
			layerUtils.iMsg(-1,"请选择需开通的账户！");
			return false;
		}
		var templateid = $(_pageId+" .sel_template").attr("templateid");
		if(templateid==null||templateid==undefined){
			layerUtils.iMsg(-1,"请选择资产账户！");
			return false;
		}
		// 检查是否勾选签署协议
		if($(_pageId+" .rule_check a").hasClass("checked"))
		{
			layerUtils.iLoading(true);  // 开启等待层。。。
			var oneData  = fristMap.get(keys[countProtocol]); // 取出一个协议
			var protocolid = oneData.get("protocolid"); // 协议ID
			var protocolname = oneData.get("protocolname");  //协议名称
			var summary = oneData.get("summary");  // 协议内容MD5,签名摘要信息
			var signParam = {
				"medid":protocolid,
				"content":summary,
				"userId":userId,
				"type": cert_type
			};
			// 获取协议的数字签名值
			require("shellPlugin").callShellMethod("signPlugin",function(data){
				var protocoldcsign = data.ciphertext;  // 数字签名值
				// 添加值到数组中
				var protocol = {
					"protocol_id" : protocolid,
					"protocol_dcsign" : protocoldcsign,
					"summary" : summary
				};
				protocolArray.push(protocol);
				countProtocol++;
				if(countProtocol < keys.length)  // 通过比较，获取每个协议的签名值
				{
					getSignProtocl();  
				}
				else  // 获取完每个签名值后 进行验签
				{
					startSign();  
				}
			},function(){
				layerUtils.iLoading(false);  // 关闭等待层
				countProtocol = 0;  // 将签署协议的计数器置为 0
			},signParam);
		}
		else
		{
			layerUtils.iMsg(-1,"请阅读并勾选同意签署以上全部协议！");
			return false;
		}
	}
	//不需要证书签署
	function getNoSignProtocl() {
			var keys = fristMap.keys(); // 协议的数量
			var oneData = fristMap.get(keys[countProtocol]); // 取出一个协议
			var protocolid = oneData.get("protocolid"); // 协议ID
			var protocolname = oneData.get("protocolname"); //协议名称
			var summary = oneData.get("summary"); // 协议内容MD5,签名摘要信息
			// 添加值到数组中
			var protocol = {
				"protocol_id": protocolid,
				"protocol_dcsign": "",
				"summary": summary
			};
			protocolArray.push(protocol);
			countProtocol++;
			if (countProtocol < keys.length) // 通过比较，获取每个协议的签名值
			{
				getNoSignProtocl();
			} else // 获取完每个签名值后 进行验签
			{
				startNoSign();
			}
		}
	
	/* 发请求进行协议验签 */
	function startSign()
	{
		countProtocol = 0;  // 将签署协议的计数器置为 0
		var signProtocolParam = {
			"user_id" : userId,
			"jsondata" : JSON.stringify(protocolArray),
			"ipaddr" : appUtils.getSStorageInfo("ip"),
			"macaddr" : appUtils.getSStorageInfo("mac")
		};
		// 新开中登验签
		if(appUtils.getSStorageInfo("openChannel") == "new")
		{
			service.queryOpenCheckSign(signProtocolParam,callSign,false);
		}
		// 转户天威验签
		else if(appUtils.getSStorageInfo("openChannel") == "change")
		{
			service.queryOpenCheckTsign(signProtocolParam,callSign,false);
		}
	}
	
	/* 验签回调函数*/
	function callSign(data)
	{
		// 如果有一个协议签署失败，就将签署结果设为 false
	    if(data.error_no == 0)
		{
			openZjAccountAndClient();	//开立账户系统客户号和资金账户
		}
	    else
	    {
			layerUtils.iLoading(false);  // 关闭等待层。。。
			layerUtils.iAlert(data.error_info,-1);
	    }
	}
	
		/* 发请求进行协议验签 */
	function startNoSign()
	{
		countProtocol = 0;  // 将签署协议的计数器置为 0
		var signProtocolParam = {
				"user_id" : userId,
				"jsondata" : JSON.stringify(protocolArray),
				"ipaddr" : appUtils.getSStorageInfo("ip"),
				"macaddr" : appUtils.getSStorageInfo("mac"),
				"checksign":"0"
		};
		// 新开中登验签
		if(appUtils.getSStorageInfo("openChannel") == "new")
		{
			service.queryOpenCheckSign(signProtocolParam,callSign,false);
		}
		// 转户天威验签
		else if(appUtils.getSStorageInfo("openChannel") == "change")
		{
			service.queryOpenCheckTsign(signProtocolParam,callSign,false);
		}
	}

	/* 开立账户系统客户号和资金账户 */
	function openZjAccountAndClient()
	{
		//开立账户系统客户号和资金账户
		var param = {
			"user_id" : appUtils.getSStorageInfo("user_id")
		};
		service.queryOpenAccount(param,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == 0)	//调用成功
			{
				// 开立中登账户
				var openStockParam = {
						"user_id" : appUtils.getSStorageInfo("user_id"),
						"sza_str" : "",  // 深A开通情况，不开传空 ，新开 1 ，转户 2
						"sha_str" : "",  //沪A开通情况
						"szfnd_str" : "",  // 深基金开通情况
						"shfnd_str" : "",  // 沪基金开通情况
						"opfnd_str" : "", // 通用开发试基金
						"templateid":$(_pageId+" .sel_template").attr("templateid") // 资产账户id
				};
				// 深 A 的开通状况
				if($(_pageId+" .radio_list ul li a[value='1']").hasClass("checked"))
				{
					if(appUtils.getSStorageInfo("openChannel") == "new" || appUtils.getSStorageInfo("finance") == "finance"){
						openStockParam.sza_str = "1";
					}else{
						openStockParam.sza_str = "2";
					}
					if($(_pageId+" .radio_list ul li a[value='1']").attr("trdacct"))
					{
						openStockParam.sza_str += $(_pageId+" .radio_list ul li a[value='1']").attr("trdacct");
					}
				}
				// 沪 A 的开通状况
				if($(_pageId+" .radio_list ul li a[value='3']").hasClass("checked"))
				{
					if(appUtils.getSStorageInfo("openChannel") == "new" || appUtils.getSStorageInfo("finance") == "finance"){
						openStockParam.sha_str = "1";
					}else{
						openStockParam.sha_str = "2";
					}
					if($(_pageId+" .radio_list ul li a[value='3']").attr("trdacct"))
					{
						openStockParam.sha_str += $(_pageId+" .radio_list ul li a[value='3']").attr("trdacct");
					}
				}
				// 新开户才有基金，转户只有 A 股
				if(appUtils.getSStorageInfo("openChannel") == "new")
				{
					// 深基金的开通状况
					if($(_pageId+" .radio_list ul li a[value='5']").hasClass("checked"))
					{
						openStockParam.opfnd_str = "1|98"+",";
					}
					// 沪基金的开通状况
					if($(_pageId+" .radio_list ul li a[value='6']").hasClass("checked"))
					{
						openStockParam.opfnd_str += "1|99";
					}
				}
				//开立中登股东账号
				service.queryOpenCompyAccount(openStockParam,function(data){
					if(data.error_no == 0)
					{
						// 标志驳回已被修改
						var notifyParam = {
							"user_id" : appUtils.getSStorageInfo("user_id"),
							"fieldname" : "account"  // 通知开股东卡已补全
						};
						service.rejectStep(notifyParam,function(data){
							if(data.error_no == 0)
							{
								//cleanPageElement();  // 清理页面元素
								appUtils.setSStorageInfo("isBack", "backInfo");  //标志重新提交资料成功
								var pwdParam = appUtils.getSStorageInfo("pwdParam");
								var thirdParam = appUtils.getSStorageInfo("thirdParam");
								if(pwdParam != null)
								{
									pwdParam = JSON.parse(pwdParam);
								}
								if(thirdParam != null)
								{
									thirdParam = JSON.parse(thirdParam);
								}
								// 需要驳回资金或交易密码
								if(pwdParam.needBusinessPwd ==1 || pwdParam.needFundPwd == 1)
								{
									appUtils.pageInit("account/backSignProtocol","account/backSetPwd",pwdParam);  //跳转设置密码页面
								}
								// 需要驳回到三方存管
								else if(thirdParam.needThirdDeposit == 1)  
								{
									appUtils.pageInit("account/backSignProtocol","account/backThirdDepository",thirdParam);  //跳转三方存管
								}
								else
								{
									appUtils.pageInit("account/backSignProtocol","account/accountResult",{});
								}
							}
							else 
							{
								layerUtils.iAlert(data.error_info,-1);
							}
						},false);
					}
					else
					{
						layerUtils.iLoading(false);
						layerUtils.iAlert(data.error_info,-1);
					}
				},false);
			}
			else
			{
				layerUtils.iLoading(false);
				layerUtils.iAlert(error_info,-1);
			}
		},false);
	}
	
	/* 清理界面元素 */
	function cleanPageElement()
	{
		$(_pageId+" .radio_list ul li").remove();  // 清理证券账户
		$(_pageId+" .rule_list ul li").remove();  // 清理协议
	}
	
	var backSignProtocol = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	module.exports = backSignProtocol;
});