/**
 * 驳回三方存管
 */
define("project/scripts/account/backThirdDepository",function(require, exports, module){ 
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
		global = require("gconfig").global,
		platform = require("gconfig").platform,
		service = require("serviceImp").getInstance(),  //业务层接口，请求数据
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		validatorUtil = require("validatorUtil"),
		zzispwd = 1,  // zzispwd	密码方式，1 需要密码，0 不需要
		iscard = 1,  // iscard	是否需要银行卡，1 需要，0 不需要
		protocol = null,  //协议保存
		cert_type = appUtils.getSStorageInfo("openChannel") == "new" ? "zd" : "tw", // tw:天威 zd:中登
		_pageId = "#account_backThirdDepository";
	var bankcodeList = new Array();
	/* 私有业务模块的全局变量 end */
	
	function init()
	{
		if(platform == '2' || platform == '3'){
			$(_pageId+" .input_text #bankcardPwd").removeAttr("readonly");
		}
		//add by gell 2015年11月25日10:53:36 证书配置相关
		if(appUtils.getSStorageInfo("flag") == "1"){//1:需要证书  0：不需要证书
			initPage();  // 初始化页面并检测证书是否存在
		}else{
			getBankListNew(); //加载银行列表
		}
	}
	
	function bindPageEvent()
	{
		/* 点击页面隐藏键盘 */
		appUtils.bindEvent($(_pageId),function(e){
			$(_pageId+" #bankListPage").slideUp("fast"); //隐藏银行卡列表
			if(platform == '1'){
				require("shellPlugin").callShellMethod("softKeyboardPlugin",null,null,{"isShow":false});  //关闭密码键盘
			}
			e.stopPropagation();  // 阻止冒泡
		});
		
		/* 签署银行相关协议  */
		appUtils.bindEvent($(_pageId+" .rule_check a"),function(){
			$(this).toggleClass("checked"); 
		});
		
		/* 选择银行卡绑定选择某银行事件 */
		appUtils.bindEvent($(_pageId+" #bankcard"),function(e){
			validateSelectBank(); // 验证是否选择银行卡
			if(platform == '1'){
				require("shellPlugin").callShellMethod("softKeyboardPlugin",null,null,{"isShow":false});  //关闭密码键盘
			}
			e.stopPropagation();  // 阻止冒泡
		});
		
		/* 银行卡号输入控制（每四位分隔） */
		appUtils.bindEvent($(_pageId+" #bankcard"),function(){
			utils.dealIPhoneMaxLength(this,21); //处理iphone兼容
			utils.showBigNo(this,2);  //调用放大镜插件
		},"input");
		
		/* 银行密码输入框 */
		appUtils.bindEvent($(_pageId+" #bankcardPwd"),function(e){
			validateSelectBank();  // 验证是否选择银行卡
			if(platform == '1'){
				utils.dealIPhoneMaxLength(this,6); // 处理iphone兼容
				var eleName = _pageId+" #bankcardPwd";
				var topHeight = $(this).offset().top + $(this).parent().height();  //当前元素到顶部的高度
				var bodyHeight = $(document.body).height();  //当前body的高度
				var pwsdParam = {"isShow":true,"oldPwd":$(this).val(),"maxLength":6, "eleName": eleName};
				require("shellPlugin").callShellMethod("softKeyboardPlugin",function(data){
					//解决弹出键盘遮挡输入框的情况
					var keyheight = data.height/window.devicePixelRatio; //键盘高度
					var newbody = bodyHeight - keyheight;  // 键盘弹出 body的高度
					var scrollheight = topHeight - newbody; // 输入框被遮住的高度
					if(scrollheight>0)  //只有当密码键盘挡住输入框的时候才进行处理
					{
						scrollheight2 = bodyHeight - $(_pageId).height() + scrollheight; //页面需要滚动的高度
						$("body").css("padding-bottom",scrollheight2+"px").scrollTop(scrollheight);
					}
				},null,pwsdParam);
			}
			e.stopPropagation();  // 阻止冒泡
		});
		
		/* 开通三方存管按钮绑定事件 */
		appUtils.bindEvent($(_pageId+" .ct_btn"),function(){
			signProtocol();  //提交验签，并且提交三方存管信息
		});
	}
	
	function bindEvents(bankItemNum) {
		if (bankItemNum != 1) {
			/* 选择银行绑定下拉框按钮事件  */
			appUtils.bindEvent($(_pageId+" #selectBank"),function(e){
				if(platform == '1'){
					require("shellPlugin").callShellMethod("softKeyboardPlugin",null,null,{"isShow":false});  //关闭密码键盘
				}
				$(_pageId+" #bankListPage ul li").removeClass("active");
				$(_pageId+" #bankListPage").slideDown("fast");  // 显示银行下拉列表
				e.stopPropagation();  // 阻止冒泡
			});
		}
	}
	
	function destroy()
	{
		service.destroy();
	}
	
	/* 初始化页面 */
	function initPage()
	{
		layerUtils.iLoading(true);  // 开启等待层。。。
		// 本页面需要用到证书，如果进入本页面时，证书不存在就下载并安装证书
		var existsParam = {
			"userId" : appUtils.getSStorageInfo("user_id"),
			"mediaid" : "certificate",
			"type" : cert_type
		};
		require("shellPlugin").callShellMethod("fileIsExistsPlugin",function(data){
			// 如果未检测到本地有证书，就安装证书
			if(data.mediaId == "")
			{
				utils.installCertificate(getBankListNew);  // 下载安装证书，并且加载银行列表
			}
			else
			{
				getBankListNew(); //加载银行列表
			}
		},function(){
			// 关闭等待层。。。
			layerUtils.iLoading(false);
		},existsParam);
	}
	
	function getBankListNew() {
		var qdId = "";
		if ("qdsw" == global.open_channel) {
			qdId = appUtils.getSStorageInfo("qdid");
		} else {
			qdId = global.open_channel;
		}
		
		if (qdId != null && qdId.length > 0) {
			var recommendno = appUtils.getSStorageInfo("recommendno");
			var branchno = appUtils.getSStorageInfo("branchno");
			var branchname = appUtils.getSStorageInfo("branchname");
			var commission = appUtils.getSStorageInfo("commission");
			var commissionname = appUtils.getSStorageInfo("commissionname");
			// if (recommendno != null && recommendno.length > 0) {
			// 	// 走过标准包或银行渠道包流程，已选择推荐人
			// 	goonOpenTip(branchname, commissionname);
			// } else {
				var isGoonOpen =  appUtils.getPageParam("goonopen");
				if (!isGoonOpen) {
					getBankListByQdId(qdId);
				} else {
					var parm = {
							"phone":appUtils.getSStorageInfo("mobileNo"),
							"operatetype" : "C",  // 根据手机号码获取渠道佣金模版
							"qd_bh" : qdId
						};
					
					service.queryChannelInfoNewByChannel(parm,function(data){
						var error_no = data.error_no;
						var error_info = data.error_info;
						if(error_no=="0"){
							var results = data.results;
							var len = results.length;
							if(len > 0){
								var isValid = false;
								for (var i = 0; i < len; i++) {
									var branchId = results[i].yyb_dm.trim(); // 营业部编号
									var branchName = results[i].yyb_name.trim(); // 营业部名称
									var templateid = results[i].cm_dm.trim(); // 佣金编号
									var templatename = results[i].cm_name.trim(); // 佣金名称
									if (branchno == branchId && templateid == commission) {
										isValid = true;
										break;
									}
								}
								
								if (isValid) {
									getBankListByQdId(qdId);
								} else {
									goonOpenTip(branchname, commissionname);
								}
							} else {
								bindEvents(0);
								getBankList();
							}
						} else {
							bindEvents(0);
							layerUtils.iLoading(false);  // 关闭等待层。。。
							layerUtils.iAlert(error_info);
						}
					},false,true,handleTimeoutNew);
				}
			// }
			
		} else {
			bindEvents(0);
			getBankList();
		}
	}
	
	function goonOpenTip(branchname, commissionname) {
		utils.layerTwoButton("您已选择" + branchname + "的" + commissionname + "开户套餐，请确认是否继续开户？","确认","取消",function(){
			bindEvents(0);
			getBankList();
		},
		function(){
			require("shellPlugin").callShellMethod("closeAppPlugin",null,null);  // 退出程序
		});
	}
	
	function getBankListByQdId(qdId) {
		var parm = {
				"phone":appUtils.getSStorageInfo("mobileNo"),
				"operatetype" : "B",  // 根据手机号码获取渠道银行
				"qd_bh" : qdId
			};
		
		service.queryChannelInfoNewByChannel(parm,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no=="0"){
				var results = data.results;
				var len = results.length;
				if(len > 0){
					bindEvents(len);
					if (len == 1) {
						var bankname = results[0].bank_name.trim(); // 三方存管名称
						var bankcode = results[0].bank_dm.trim(); // 三方存管编号
						
						utils.layerTwoButton("三方存管只能选择" + bankname +  "，是否继续开户？","退出应用","继续开户",
								function(){require("shellPlugin").callShellMethod("closeAppPlugin",null,null);  // 退出程序
								}, function(){return false;});
						
						// var isbuffet = "1", // 是否支持自助
						// sign_info = "", // 提示信息简介
						// brief = ""; // 银行简介
						
						// if (bankcode == "JTCG") {
						// 	zzbindtype = "2"; 
						// } else {
						// 	zzbindtype = "1"; // 绑定方式：1 一步式 2 预指定 3 同时支持两种方式
						// }
						
						// if (bankcode == "JHCG" || bankcode == "ZHCG" || bankcode == "XYCG" || bankcode == "MSCG") {
						// 	zzispwd = "1"; // 密码方式：1 需要 0 不需要  
						// } else {
						// 	zzispwd = "0";
						// }
						
						// iscard = ""; // 卡号方式：1 需要 0 不需要  

						try {
							bankcodeList = [];
							bankcodeList = new Array();
							bankcodeList.push(bankcode);
						} catch (exception) {
							console.log(exception.name + ": " + exception.message)
						}

						var queryParam = {"bindtype" : "", "ispwd" : ""};
						service.queryBankList(queryParam,function(dataIn){
							var errorNoIn = dataIn.error_no;
							var errorInfoIn = dataIn.error_info;
							if(errorNoIn == 0 && dataIn.results.length != 0)
							{
								var resultsIn = dataIn.results;
								var lengthIn = resultsIn.length;
								var isValid = false;
								var bankcode,  // 银行代码
									bankname,  // 银行名称
									sortnum,  // 排序
									smallimg, // 图标
									isbuffet, // 是否支持自助
									sign_info, // 提示信息简介
									brief; // 银行简介
									
								for(var i =0; i<lengthIn; i++)
								{
									var item = resultsIn[i];
									bankcode = item.bankcode;  // 银行代码
									bankname = item.bankname;  // 银行名称
									sortnum  = item.sortnum;  // 排序
									smallimg = item.smallimg; // 图标
									isbuffet = item.isbuffet; // 是否支持自助
									sign_info = item.sign_info; // 提示信息简介
									brief = item.brief; // 银行简介
									zzbindtype = item.zzbindtype; // 绑定方式：1 一步式 2 预指定 3 同时支持两种方式
									zzispwd = item.zzispwd; // 密码方式：1 需要 0 不需要  
									iscard = item.iscard; // 卡号方式：1 需要 0 不需要
									if (-1 != bankcodeList.indexOf(bankcode)) {
										isValid = true;
										break;
									}
								}

								if (isValid) {
									if((appUtils.getSStorageInfo("_prePageCode") == "account/showProtocol") || (appUtils.getSStorageInfo("_prePageCode") == "account/thirdDepository")){
										var bankNum = appUtils.getSStorageInfo("bankNum");
										var bankPwd = appUtils.getSStorageInfo("bankPwd",true);
										console.log(bankNum + "~~~~~~~~~~~~" + bankPwd);
										iscard = $(_pageId+" #selectBank").attr("iscard");
										$(_pageId+" #bankcard").val(bankNum);
										$(_pageId+" #bankcardPwd").val(bankPwd);
									}
									
									$(_pageId+" .protocolshow").show();
									$(_pageId+" #selectBank").removeClass("sel_text").addClass("sel_text_fixed");
									protocolArrayNoCert = new Array();
									addBankItem(bankname,bankcode,zzbindtype,sign_info,iscard);
									$(_pageId+" #selectBank").unbind();
								}
								
								layerUtils.iLoading(false);
							}
							else
							{
								layerUtils.iLoading(false);
								layerUtils.iAlert(errorInfo,-1);
							}
						},true,true,handleTimeout);
						
					} else {
						bankcodeList = [];
						bankcodeList = new Array();
						for (var i = 0; i < len; i++) {
							var bankname = results[i].bank_name.trim(); // 三方存管名称
							var bankcode = results[i].bank_dm.trim(); // 三方存管编号
							
							// var isbuffet = "1", // 是否支持自助
							// sign_info = "", // 提示信息简介
							// brief = ""; // 银行简介
							
							// if (bankcode == "JTCG") {
							// 	zzbindtype = "2"; 
							// } else {
							// 	zzbindtype = "1"; // 绑定方式：1 一步式 2 预指定 3 同时支持两种方式
							// }
							
							// if (bankcode == "JHCG" || bankcode == "ZHCG" || bankcode == "XYCG" || bankcode == "MSCG") {
							// 	zzispwd = "1"; // 密码方式：1 需要 0 不需要  
							// } else {
							// 	zzispwd = "0";
							// }
							
							// iscard = ""; // 卡号方式：1 需要 0 不需要 

							bankcodeList.push(bankcode);
							
							
						}

						var queryParam = {"bindtype" : "", "ispwd" : ""};
						service.queryBankList(queryParam,function(dataIn){
							var itemElement = "";
							var errorNoIn = dataIn.error_no;
							var errorInfoIn = dataIn.error_info;
							if(errorNoIn == 0 && dataIn.results.length != 0)
							{
								var resultsIn = dataIn.results;
								var lengthIn = resultsIn.length;
								var isValid = false;
								var bankcode,  // 银行代码
									bankname,  // 银行名称
									sortnum,  // 排序
									smallimg, // 图标
									isbuffet, // 是否支持自助
									sign_info, // 提示信息简介
									brief; // 银行简介
									
								for(var i =0; i<lengthIn; i++)
								{
									var item = resultsIn[i];
									bankcode = item.bankcode;  // 银行代码
									bankname = item.bankname;  // 银行名称
									sortnum  = item.sortnum;  // 排序
									smallimg = item.smallimg; // 图标
									isbuffet = item.isbuffet; // 是否支持自助
									sign_info = item.sign_info; // 提示信息简介
									brief = item.brief; // 银行简介
									zzbindtype = item.zzbindtype; // 绑定方式：1 一步式 2 预指定 3 同时支持两种方式
									zzispwd = item.zzispwd; // 密码方式：1 需要 0 不需要  
									iscard = item.iscard; // 卡号方式：1 需要 0 不需要
									if (-1 != bankcodeList.indexOf(bankcode)) {
										isValid = true;
										itemElement += "<li><span bankname='"+bankname+"' id='"+bankcode+"' " +"zzispwd=\""+zzispwd+"\""+
											"iscard=\""+iscard+"\"  zzbindtype=\""+zzbindtype+"\" sign-info=\""+sign_info+"\">"+bankname+"</span></li>";
									}
								}
								if (isValid) {
									$(_pageId+" .sel_list ul").html(itemElement);
									if((appUtils.getSStorageInfo("_prePageCode") == "account/showProtocol") || (appUtils.getSStorageInfo("_prePageCode") == "account/thirdDepository")){
										var bankNum = appUtils.getSStorageInfo("bankNum");
										var bankPwd = appUtils.getSStorageInfo("bankPwd",true);
										console.log(bankNum + "~~~~~~~~~~~~" + bankPwd);
										iscard = $(_pageId+" #selectBank").attr("iscard");
										$(_pageId+" #bankcard").val(bankNum);
										$(_pageId+" #bankcardPwd").val(bankPwd);
									}
									// 选择银行添加银行事件
									appUtils.bindEvent($(_pageId+" #bankListPage ul li span"),function(e){
										$(_pageId+" #bankListPage ul li").removeClass("active");
										$(this).parent().addClass("active");
										$(_pageId+" .protocolshow").show();
										var banckName = $(this).attr("bankname"),
										id = $(this).attr("id"),
										signInfo = $(this).attr("sign-info");  // 提示信息
										zzbindtype = $(this).attr("zzbindtype"); // 绑定方式
										zzispwd = $(this).attr("zzispwd");  // 密码方式
										iscard = $(this).attr("iscard");  // 是否需要银行卡号
										protocolArrayNoCert = new Array();
										addBankItem(banckName,id,zzbindtype,signInfo,iscard);
										e.stopPropagation();
									});
								}
								
								layerUtils.iLoading(false);
							}
							else
							{
								layerUtils.iLoading(false);
								layerUtils.iAlert(errorInfo,-1);
							}
						},true,true,handleTimeout);
						
						
					}
				} else {
					// 没有配置
					bindEvents(0);
					getBankList();
				}
			} else {
				bindEvents(0);
				layerUtils.iLoading(false);
				layerUtils.iAlert(errorInfo,-1);
			}
		},true,true,handleTimeoutNew);
	}
	
	/* 获取存管银行列表 */
	function getBankList()
	{
		var queryParam = {"bindtype" : "", "ispwd" : ""};
		service.queryBankList(queryParam,function(data){
			var errorNo = data.error_no;
			var errorInfo = data.error_info;
			$(_pageId+" .sel_list ul").html("");  // 清除页面的银行列表
			if(errorNo==0 && data.results.length != 0)
			{
				var results = data.results;
				var length = results.length;
				var itemElement = "";
				for(var i =0; i<length; i++)
				{
					var item = results[i],
					bankcode = item.bankcode,  // 银行代码
					bankname = item.bankname,  // 银行名称
					sortnum  = item.sortnum,  // 排序
					smallimg = item.smallimg, // 图标
					isbuffet = item.isbuffet, // 是否支持自助
					sign_info = item.sign_info, // 提示信息简介
					brief = item.brief; // 银行简介
					zzbindtype = item.zzbindtype; // 绑定方式：1 一步式 2 预指定 3 同时支持两种方式
					zzispwd = item.zzispwd; // 密码方式：1 需要 0 不需要  
					iscard = item.iscard; // 卡号方式：1 需要 0 不需要  
					itemElement += "<li><span bankname='"+bankname+"' id='"+bankcode+"' " +"zzispwd=\""+zzispwd+"\""+
					"iscard=\""+iscard+"\"  zzbindtype=\""+zzbindtype+"\" sign-info=\""+sign_info+"\">"+bankname+"</span></li>";
				}
				$(_pageId+" .sel_list ul").html(itemElement);
				// 选择银行添加银行事件
				appUtils.bindEvent($(_pageId+" #bankListPage ul li span"),function(e){
					$(_pageId+" #bankListPage ul li").removeClass("active");
					$(this).parent().addClass("active");
					$(_pageId+" .protocolshow").show();
					var banckName = $(this).attr("bankname"),
					id = $(this).attr("id"),
					signInfo = $(this).attr("sign-info");  // 提示信息
					zzbindtype = $(this).attr("zzbindtype"); // 绑定方式
					zzispwd = $(this).attr("zzispwd");  // 密码方式
					iscard = $(this).attr("iscard");  // 是否需要银行卡号
					addBankItem(banckName,id,zzbindtype,signInfo);
					e.stopPropagation();
				});
				layerUtils.iLoading(false);
			}
			else
			{
				layerUtils.iLoading(false);
				layerUtils.iAlert(errorInfo,-1);
			}
		},true,true,handleTimeout);	
	}
	
	/* 处理请求超时 */
	function handleTimeout()
	{
		layerUtils.iLoading(false);
		layerUtils.iConfirm("请求超时，是否重新加载？",function(){
			layerUtils.iLoading(true);
			getBankList();  // 再次获取银行列表
		});
	}
	
	/* 处理请求超时 */
	function handleTimeoutNew()
	{
		layerUtils.iLoading(false);
		layerUtils.iConfirm("请求超时，是否重新加载？",function(){
			layerUtils.iLoading(true);
			getBankListNew();  // 再次获取银行列表
		});
	}
	
	/* 为选择银行列表添加选中银行数据 */
	function addBankItem(banckName,id,zzbindtype,signInfo)
	{
		// 显示银行的签约信息
		if(signInfo != "" && signInfo != undefined)
		{
			$(_pageId+" #signInfo").html("温馨提示: "+signInfo);
		}
		else 
		{
			$(_pageId+" #signInfo").html(""); 
		}
		$(_pageId+" #bankcard").val("");  // 清空银行卡号值
		$(_pageId+" #bankcardPwd").val(""); // 清空银行卡密码
		$(_pageId+" #selectBank").html(banckName);  // 赋值银行卡名称
		$(_pageId+" #selectBank").attr("bankcode",id);
		$(_pageId+" #selectBank").attr("zzbindtype",zzbindtype);
		getDepositoryAgreement(id);  // 获取银行协议内容
		if(zzbindtype == 1)   // 判断一步式
		{
			if(zzispwd == 0)  // 不需要输入密码
			{
				$(_pageId+" #bankcardPwd").parent().hide();  // 隐藏银行密码输入框
			}
			else   // 需要输入密码
			{
				$(_pageId+" #bankcardPwd").parent().show();  // 显示银行密码输入框
			}
			$(_pageId+" .user_form .input_form:eq(1)").show();  // 显示银行卡、密码输入框
			$(_pageId+" #bindInfo").hide();  // 隐藏预指定提示信息
		}
		if(zzbindtype == 2)  // 判断预指定(二步式)
		{
			if(iscard == 1)  // 需要银行卡
			{
				$(_pageId+" .user_form .input_form:eq(1)").show();  // 显示银行卡
				$(_pageId+" .user_form .input_form:eq(1) .input_text:eq(1)").hide();  // 隐藏密码
			}
			else // 不需要银行卡
			{
				$(_pageId+" .user_form .input_form:eq(1)").hide();  // 隐藏银行卡、密码输入框
			}
			$(_pageId+" #bindInfo").show();  // 显示预指定提示信息
		}
		$(_pageId+" #bankListPage").slideUp("fast");  // 隐藏银行下拉列表
	}
	
	/* 签署协议 */
	function signProtocol()
	{
		if(!validateSelectBank())  // 验证是否选择银行
		{
			return false;
		}
		if(iscard == 1 && !validateBankCorrect())  // 验证银行卡号
		{
			return false;
		}
		if(iscard == 1 && zzispwd == 1)  // 验证是否需要密码
		{
			if(!validateBankPwd())
			{
				return false;
			}
		}
		if(!validateDepositProtocolSelect())  // 验证是否勾选协议
		{
			return false;
		}
		//add by gell 2015年11月25日10:53:36 证书配置相关
		if(appUtils.getSStorageInfo("flag") == "1"){//1:需要证书  0：不需要证书
			// 进行协议签署
			var protocolArray = new Array(),  // 协议数组
				userid = appUtils.getSStorageInfo("user_id"),
				ipaddr  = appUtils.getSStorageInfo("ip"),
				macaddr = appUtils.getSStorageInfo("mac"),
				protocolid = protocol.econtract_no,
				protocolname = protocol.econtract_name,
				summary = protocol.econtract_md5,  // 协议内容MD5,签名摘要信息
				signParam = {
					"medid":protocolid,
					"content":summary,
					"userId":userid,
					"type": cert_type
				};
			layerUtils.iLoading(true);  // 开启等待层......
			// 获取协议的数字签名值
			require("shellPlugin").callShellMethod("signPlugin",function(data){
				var protocoldcsign = data.ciphertext;  // 数字签名值
				var protocolParam = {
					"protocol_id" : protocolid,
					"protocol_dcsign" : protocoldcsign,
					"summary" : summary
				};
				protocolArray.push(protocolParam);   // 添加值到数组中
				// 签署协议
				var signProtocolParam = {
					"user_id" : userid,
					"jsondata" : JSON.stringify(protocolArray),
					"ipaddr" : ipaddr,
					"macaddr" : macaddr
				};
				// 新开中登验签
				if(appUtils.getSStorageInfo("openChannel") == "new")
				{
					service.queryOpenCheckSign(signProtocolParam,postThirdDepositoryData,false);
				}
				// 转户天威验签
				else if(appUtils.getSStorageInfo("openChannel") == "change")
				{
					service.queryOpenCheckTsign(signProtocolParam,postThirdDepositoryData,false);
				}
			},function(){ layerUtils.iLoading(false); },signParam);
		}else{
				// 进行协议签署
				var protocolArray = new Array(),  // 协议数组
				userid = appUtils.getSStorageInfo("user_id"),
				ipaddr  = appUtils.getSStorageInfo("ip"),
				macaddr = appUtils.getSStorageInfo("mac"),
				protocolid = protocol.econtract_no,
				protocolname = protocol.econtract_name,
				summary = protocol.econtract_md5,  // 协议内容MD5,签名摘要信息

				var protocolParam = {
					"protocol_id": protocolid,
					"protocol_dcsign": "",
					"summary": summary
				};
				layerUtils.iLoading(true);  // 开启等待层......
				protocolArray.push(protocolParam);   // 添加值到数组中

				// 签署协议
				var signProtocolParam = {
					"user_id": userid,
					"jsondata": JSON.stringify(protocolArray),
					"ipaddr": ipaddr,
					"macaddr": macaddr,
					"checksign": "0"
				};
				service.queryOpenCheckSign(signProtocolParam, postThirdDepository_Data, false);
				//postThirdDepository_Data();
		}

	}
	
	/* 提交三方存管银行数据 */
	function postThirdDepositoryData()
	{
		service.getRSAKey({}, function(data) {
			if( data.error_no==0)	//请求获取rsa公钥成功
			{
				//密码采用rsa加密
				var results = data.results[0];
				var modulus = results.modulus;
				var publicExponent =  results.publicExponent;
				var endecryptUtils = require("endecryptUtils");
				
				var bankpwd = endecryptUtils.rsaEncrypt(modulus, publicExponent, $(_pageId+" #bankcardPwd").val().trim());
				var userid = appUtils.getSStorageInfo("user_id");
				var bankcode= $(_pageId+" #selectBank").attr("bankcode");
				var bankaccount = $(_pageId+" #bankcard").val();
				var thirdDepositParam = {
					"user_id":userid,
					"acct_clientid":"",
					"acct_fndacct":"",
					"bank_code":bankcode,
					"bank_account":bankaccount,
					"bank_pwd":bankpwd,
					"op_type":$(_pageId+" #selectBank").attr("zzbindtype")
				};
				//调用service绑定存管银行
				service.bindBank(thirdDepositParam,function(data){
					var errorNo = data.error_no;
					var errorInfo = data.error_info;
					if(errorNo==0)	 //调用成功,则跳到结果页
					{
						var notifyParam = {
							"user_id" : appUtils.getSStorageInfo("user_id"),
							"fieldname" : "bind_bank"  // 通知三方存管已补全
						};
						service.rejectStep(notifyParam,function(data){
							if(data.error_no == 0)
							{
								appUtils.setSStorageInfo("isBack", "backInfo");  //标志重新提交资料成功
								appUtils.pageInit("account/backThirdDepository","account/accountResult",{});  //返回结果页
							}
							else 
							{
								layerUtils.iAlert(data.error_info,-1);
							}
						},false);
					}
					else
					{
						layerUtils.iLoading(false);
						layerUtils.iAlert(errorInfo,-1);
					}
				},false);
			}
			else
			{
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info);
			}
		}, false);
	}
	
	/* 验证是否选择银行  */
	function validateSelectBank()
	{
		var obj = $(_pageId+" #selectBank");
		var value = obj.html();
		if(validatorUtil.isEmpty(value)||value=="请选择银行")
		{
			layerUtils.iMsg(-1,"请选择银行");
			return false;
		}
		return true;
	}
	
	/* 检验银行卡填写是否正确 */
	function validateBankCorrect()
	{
		var bankcard = $(_pageId+" #bankcard").val();
		if(bankcard == "")//验证通过的情况
		{
			layerUtils.iMsg(-1,"银行卡号不能为空！");
			return false;
		}
		if(!validatorUtil.isBankCode(bankcard))
		{
			layerUtils.iMsg(-1,"银行卡号格式有误，请重新输入！");
			return false;
		}
		return true;
	}
	
	/* 验证银行密码 */
	function validateBankPwd()
	{
		//验证不通过
		var cardPwd = $(_pageId+" #bankcardPwd").val();
		if(!validatorUtil.isNumeric(cardPwd) || cardPwd.length !=6)
		{
			layerUtils.iMsg(-1,"银行卡密码有误，请重新输入！");
			return false;
		}
		return true;
	}
	
	/* 检测勾选阅读协议 */
	function validateDepositProtocolSelect()
	{
		if(!$(_pageId+" .icon_check").hasClass("checked"))
		{
			layerUtils.iMsg(-1,"请阅读并勾选三方存管协议!");
			return false;
		}
		return true;
	}
	
	/* 获取存管银行签约电子协议列表 */
	function getDepositoryAgreement(bankcode)
	{
		// 获取银行协议的参数
		var param = {
			"econtract_no" : bankcode
		};
		//调用service查询存管银行协议
		service.queryProtocolList(param,function(data){
			$(_pageId+" #protocolName").html("");
			if(data.error_no == 0)
			{
				if(data.results&&data.results.length>=1){
					protocol = data.results[0];
					$(_pageId+" #protocolName").html("《"+protocol.econtract_name+"》");
					$(_pageId+" #protocolName").attr("protocolId",protocol.econtract_no);
					$(_pageId+" #protocolName").attr("protocolMd5",protocol.econtract_md5);
					// 预绑定查看银行协议内容的事件
					appUtils.preBindEvent($(_pageId+" #protocolName").parent(),"#protocolName",function(){
						appUtils.pageInit("account/thirdDepository","account/showProtocol",{"protocol_id":$(_pageId+" #protocolName").attr("protocolId")});
					});
				}
			}
			else
			{
				layerUtils.iAlert(data.error_info,-1);
			}
		});
	}

	/*提交三方存管银行数据*/
	function postThirdDepository_Data(){
		service.getRSAKey({},function(data){
			if(data.error_no == 0){//请求获取RSA公钥成功
				//秘钥用来rsa加密
				var results = data.results[0];
				var modulus = results.modulus;
				var publicExponent = results.publicExponent;
				var endecryptUtils = require("endecryptUtils");

				var bankpwd = endecryptUtils.rsaEncrypt(modulus,publicExponent,$(_pageId+" #bankcardPwd").val().trim());
				var userid = appUtils.getSStorageInfo("user_id");
				var bankcode = $(_pageId+" #selectBank").attr("bankcode");
				var bankaccount = $(_pageId+" #bankcard").val();
				var thirdDepositParam={
					"user_id":userid,
					"acct_clientid":"",
					"acct_fndacct":"",
					"bank_code":bankcode,
					"bank_account":bankaccount,
					"bank_pwd":bankpwd,
					"op_type":$(_pageId+" #selectBank").attr("zzbindtype")
				};
				// 调用service绑定存管银行
				service.bindBank(thirdDepositParam,function(data){
					var errorNo = data.error_no;
					var errorInfo = data.error_info;
					if(errorNo==0)	 // 调用成功,跳转到风险测评页面
					{
						cleanPageElement();
						appUtils.pageInit("account/thirdDepository","account/riskAssessment",{});
					}
					else
					{
						layerUtils.iLoading(false);
						layerUtils.iAlert(errorInfo,-1);
					}
				},false);
			}else{
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info,-1);
			}
		},false);
	}
	
	/* 清理界面元素 */
	function cleanPageElement()
	{
		$(_pageId+" .rule_check a").removeClass("checked");  // 取消勾选协议
		$(_pageId+" #selectBank").text("请选择银行");  // 清理银行卡的名字
		$(_pageId+" #bankcard").val("");  // 清理银行卡号
		$(_pageId+" #bankcardPwd").val("");  // 清理密码
		$(_pageId+" #protocolName").text("《券商银行投资者三方协议》");  // 清理协议名
		$(_pageId+" #signInfo").html("");  // 清除银行签约信息
	}
	
	var backThirdDepository = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	// 暴露对外的接口
	module.exports = backThirdDepository;
});