/**
 * 填写个人信息
 */
define("project/scripts/account/personInfo1",function(require, exports, module){ 
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
	    service = require("serviceImp").getInstance(),  //业务层接口，请求数据
		global = require("gconfig").global,
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		validatorUtil = require("validatorUtil");
	var _pageId = "#account_personInfo1";
	var external = require("external");




	/* 私有业务模块的全局变量 end */

	function init()
	{
		_pageId = "#account_personInfo1";
		queryZhengXin()
	}

	function bindPageEvent()
	{

		appUtils.bindEvent($(_pageId+" #switch_box1"), function () {
            if(!this.checked){
            	layerUtils.iAlert("尊敬的投资者，账户实际控制人必须为本人，如有疑问请临柜办理开户业务！",-1);
            	this.checked = true;
            }
        }, 'change')
        
        appUtils.bindEvent($(_pageId+" #switch_box2"), function () {
            if(!this.checked){
            	layerUtils.iAlert("尊敬的投资者，账户实际受益人必须为本人，如有疑问请临柜办理开户业务！",-1);
            	this.checked = true;
            }
        }, 'change')
        
        appUtils.bindEvent($(_pageId+" #zc_check .icon_radio"), function () {
        	$(this).toggleClass("checked")
            $(this).parent().siblings().find("span").toggleClass("checked")
			$(_pageId+" #zx_detail").slideToggle()
        })
        
        appUtils.bindEvent($(_pageId+" #ss_check .icon_radio"), function () {
        	$(this).toggleClass("checked")
        	if($(this).hasClass("checked")){
        		$(this).parent().siblings().find("span").removeClass("checked")
        	}else{
        	//	$(this).parent().siblings().find("span").addClass("checked")
        	}
        })
        
        appUtils.bindEvent($(_pageId+" #shuishou"), function () {
			var taxrevenue = "";
			$(_pageId+" #ss_check").find(".icon_radio").each(function(){
				if($(this).hasClass("checked")){
					taxrevenue = $(this).attr("value");
				}
			})
        	appUtils.pageInit("account/personInfo1","account/tax",{"taxrevenue":taxrevenue})
        })
        
        /* 绑定下一步 */
		appUtils.bindEvent($(_pageId+" .fix_bot .ct_btn"),function(){
			if(verifyInfo())  // 校验数据
			{
				submitInfo();  //提交用户信息
			}
		});
		
		/* 绑定返回 */
		appUtils.bindEvent($(_pageId+" .header .icon_back"),function(){
			pageBack();
		});
	}

	/* 处理返回按钮 */
	function pageBack()
	{
		appUtils.pageBack();
	}

	function destroy()
	{
		service.destroy();
	}

	/*提交开户信息*/
	function submitInfo()
	{
		// 开户信息资料提交
		var param = setSubmitDataParam();
		layerUtils.iAlert("尊敬的投资者,以上内容均是根据您本人(账户所有人)意愿填写,并保证其真实、准确、有效。如因填写虚假信息、错误、无效导致的一切风险和损失，一律由您本人自行承担。为保证您账户权益，若您信息发生重要变化应及时告知所属开户营业部。同时您办理修改关键信息及转销户等业务需本人至开户营业部临柜办理。",-1,ok);
		function ok(){
			service.submitUserInfo(param,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == 0)
			{
				appUtils.setSStorageInfo("idCardNo",param.idno);
				appUtils.setSStorageInfo("custname",param.custname);
				appUtils.setSStorageInfo("addr",param.addr);
				//新开，则走新开流程
				if(appUtils.getSStorageInfo("openChannel") == "new")
				{
					// 跳转到视频见证页面
					appUtils.pageInit("account/personInfo1","account/videoNotice",{});
				}
				// 转户，则走转户流程
				else if(appUtils.getSStorageInfo("openChannel") == "change")
				{
					// 转户，模拟视频见证通过，否则下载证书的时候后台  会出现 cert_uid 错误
					var syncQQUserInfoParam = {
						user_id : appUtils.getSStorageInfo("user_id")
					};
					// 模拟视频通过
					service.syncQQUserInfo(syncQQUserInfoParam,function(data){
						var error_no = data.error_no;
						var error_info = data.error_info;
						if(error_no == 0)
						{
							//add by gell 2015年11月25日10:53:36 证书配置相关
							if(appUtils.getSStorageInfo("flag") == "1"){//1:需要证书  0：不需要证书
								// 跳转到数字证书页面
								appUtils.pageInit("account/personInfo1","account/digitalCertificate",{});
							}else{
								appUtils.pageInit("account/personInfo1","account/signProtocol",{});
							}
						}
						else
						{
							layerUtils.iLoading(false);
							layerUtils.iAlert(error_info,-1);
						}
					});
				}
			}
			// 转户走了新开，提示走转户
			else if(error_no == -50152819)
			{
				layerUtils.iLoading(false);
				utils.layerTwoButton("系统检测到您已开立证券账户为：【"+error_info+"】，请进行转户流程!","马上转户","退出系统",function(){
					changeState(); // 走转户流程
				},function(){
					 var param={
				         		"funcNo":"50105"
						        }
					 external.callMessage(param);   // 退出系统

				});
			}
			// 新开走了转户，提示走新开流程
			else if(error_no == -50152820)
			{
				appUtils.setSStorageInfo("idCardNo",param.idno);
				appUtils.setSStorageInfo("custname",param.custname);
				layerUtils.iLoading(false);
				utils.layerTwoButton("您未开通股东账户，请走新开流程!","立即开户","退出系统",function(){
					newOpen();  //走新开流程
				},function(){
					 var param={
				         		"funcNo":"50105"
						        }
					 external.callMessage(param); // 退出程序

				});
			}
			// 新开查到单边市场
			else if(error_no == -50152829)
			{
				appUtils.setSStorageInfo("idCardNo",param.idno);
				appUtils.setSStorageInfo("custname",param.custname);
				layerUtils.iLoading(false);
				utils.layerTwoButton("系统检测到您已开立证券账户为：【"+error_info+"】","继续开户","马上转户",function(){
					newOpen();  // 走新开流程
				},function(){
					changeState(); // 走转户流程
				});
			}
			else
			{
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info);  // 填写资料失败，弹出提示
			}
		},false);
		}
	}

	/* 改变流程状态，走转户 */
	function changeState()
	{
		// session中的openChannel改为转户
		appUtils.setSStorageInfo("openChannel","change");
		var newopenParam = {
			user_id : appUtils.getSStorageInfo("user_id"),
			uploadimg_flag:"0",
			opacctkind_flag:"1"  // 转户
		}
		service.queryChangeState(newopenParam,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == 0)
			{
				// 跳转之前，修改 session 中 photosInfo 的 fillInformationInParam
				var param = setSubmitDataParam();
				var photosInfo = JSON.parse(appUtils.getSStorageInfo("photosInfo"));
				// 设置 photosInfo 的 isChangeProcess 属性，true 是更改流程
				photosInfo.isChangeProcess = true;
				photosInfo.fillInformationInParam.idno = param.idno;
				photosInfo.fillInformationInParam.custname = param.custname;
				photosInfo.fillInformationInParam.native = param.native;  // 证件地址
				photosInfo.fillInformationInParam.policeorg = param.policeorg;  // 签发机关
				photosInfo.fillInformationInParam.birthday = param.birthday;  // 出生日期
				photosInfo.fillInformationInParam.idbegindate = param.idbegindate;
				photosInfo.fillInformationInParam.idenddate = param.idEndDate;
				photosInfo.fillInformationInParam.postid = param.postid;  // 邮政编码
				// 职业
				photosInfo.fillInformationInParam.occupation = {
					"text" : param.profession_text,
					"value" : param.profession_code
				};
				// 学历
				photosInfo.fillInformationInParam.degree = {
					"text" : param.edu_text,
					"value" : param.edu
				};
				// 重新设置  session 中 photosInfo
				appUtils.setSStorageInfo("photosInfo",JSON.stringify(photosInfo));
				// 跳到转户的上传照片页面
				appUtils.pageInit("account/personInfo1","account/uploadPhotoChange",{});
			}
			else
			{
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info,-1);
			}
		},false);
	}

	/*走新开户*/
	function newOpen()
	{
		// session中的openChannel改为新开
		appUtils.setSStorageInfo("openChannel","new");
		var newopenParam = {
			user_id : appUtils.getSStorageInfo("user_id"),
			uploadimg_flag:"1",  //身份证上传成功
			opacctkind_flag:"0"  //新开户
		}
		service.queryChangeState(newopenParam,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == 0)
			{
				// 再次调用提交用户信息接口, 添加入参submitflag =0
				var param = setSubmitDataParam();
				param.submitflag = "0" ;
				service.submitUserInfo(param,function(data){
					var error_no = data.error_no;
					var error_info = data.error_info;
					if(error_no == 0)
					{
						appUtils.pageInit("account/personInfo1","account/videoNotice",{});  // 跳转到视频见证页面
					}
					else
					{
						layerUtils.iLoading(false);
						layerUtils.iAlert(data.error_info);
					}
				});
			}
			else
			{
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info,-1);
			}
		},false);
	}

	/* 获取用户信息*/
	function setSubmitDataParam()
	{
		var creditrecord = "",taxrevenue = "";
		if($(_pageId+" #zc_check").find(".icon_radio:eq(0)").hasClass("checked")){//无不良诚信记录
			creditrecord = "0";
		}
		if(creditrecord == ""){//有不良诚信记录
			$(_pageId+" #zx_detail").find(".icon_radio").each(function(){
				if($(this).hasClass("checked")){
					creditrecord += $(this).attr("value") + ",";
				}
			})
			creditrecord = creditrecord.substring(0,creditrecord.length-1);
		}
		
		$(_pageId+" #ss_check").find(".icon_radio").each(function(){
			if($(this).hasClass("checked")){
				taxrevenue = $(this).attr("value");
			}
		})
		var param = JSON.parse(appUtils.getSStorageInfo("personInfo"))
		param.accountcontrollerme = $(_pageId+" #switch_box1").is(':checked')?1:0  //账户实际控制人是否为本人  1：是  0：否
		param.accountbeneficiaryme = $(_pageId+" #switch_box2").is(':checked')?1:0  //账户实际受益人是否为本人  1：是  0：否
		param.manager = $(_pageId+" #switch_box3").is(':checked')?1:0  //是否担任董事、监事或高级管理人员  1：是  0：否
		param.creditrecord=creditrecord
		param.taxrevenue=taxrevenue
		return param;
	}
	
	/* 查询征信*/
	function queryZhengXin(){
		$(_pageId+" #zx_detail ul").html("");
		var param = {"enum_type" : "creditrecord"};
		service.queryDataDict(param,function(data){
			var error_no = data.error_no,
      		      error_info = data.error_info;
			if(error_no == "0" && data.results.length != 0)
			{
				var results = data.results;
				var str = "";
				for(var i=0;i<results.length;i++)
				{
					str = '<li><span id="zx'+i+'" class="icon_radio" value='+results[i].item_value+'>'+results[i].item_name+'</span></li>'
					$(_pageId+" #zx_detail ul").append(str);
					BindSelectZhengXin(i);
				}
			}
			else
			{
				layerUtils.iLoading(false);
				layerUtils.iMsg(-1,error_info);  // 提示错误信息
			}
		},{"timeOutFunc":handleTimeout});
	}
	
	function BindSelectZhengXin(i){
    	appUtils.bindEvent($("#zx"+i), function (e) {
        	$("#zx"+i).toggleClass("checked")
        	e.stopPropagation();  // 阻止冒泡
        })
    }

	/* 处理请求超时 */
	function handleTimeout()
	{
		layerUtils.iConfirm("请求超时，是否重新加载？",function(){
			queryZhengXin();  // 再次获取征信
		});
	}

	/* 信息提交校验 */
	function verifyInfo()
	{
		var flag111 = false;
		if($(_pageId+" #zc_check").find(".icon_radio:eq(1)").hasClass("checked")){//有不良诚信记录
			$(_pageId+" #zx_detail").find(".icon_radio").each(function(){
				if($(this).hasClass("checked")){
					flag111 = true;
				}
			})
			if(!flag111){
				layerUtils.iAlert("请至少选择一条不良诚信记录！",-1)
				return false;
			}
		}
		
		var ppp = "";
		$(_pageId+" #ss_check").find(".icon_radio").each(function(){
			if($(this).hasClass("checked")){
				ppp = $(this).attr("value");
			}
		})
		if(ppp == ""){
			layerUtils.iAlert("请至少选择一种个人税收声明！",-1)
			return false;
		}
		if(ppp == "0"){
			layerUtils.iAlert("尊敬的投资者，非中国税收居民不允许网上开户！",-1)
			return false;
		}
		if(ppp == "2"){
			layerUtils.iAlert("尊敬的投资者，既是中国税收居民又是其他国家(地区)税收居民不允许网上开户！",-1)
			return false;
		}
		return true;
	}

	var personInfo1 = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"pageBack" : pageBack,
		"destroy" : destroy
	};
	
	module.exports = personInfo1;
});