/*
* 风险测评
*/
define("project/scripts/account/riskAssessment",function(require,exports,module){
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
		  service = require("serviceImp").getInstance(),  //业务层接口，请求数据
		  global = require("gconfig").global,
		  layerUtils = require("layerUtils"),
		  Map = require("map"),
		  fristMap = "",
		  fanxiqianMap = "",
		  wjdcMap = "",
		  info = "",
		  fengxian_sub_id = "",
		  fanxiqian_sub_id = "",
		  huifang_sub_id = "",
		  invest_term = "", //投资期限
		  invest_variety = "",	//投资品种
		  _pageId = "#account_riskAssessment";
	/* 私有业务模块的全局变量 end */
	
	function init()
	{
		/* 绑定返回 */
		appUtils.bindEvent($(_pageId+" .header .icon_back"),function(){
			appUtils.pageInit("account/riskAssessment","account/thirdDepository",{});
		});
		getInfo();
		fristMap = new Map(); //风险测评
		fanxiqianMap = new Map();	//反洗钱测评
		wjdcMap = new Map();	//反洗钱测评
		getRiskAssessQuestions();  // 获取问卷答题
	}
	
	function bindPageEvent()
	{
		/* 提交答题  */
		appUtils.preBindEvent($(document),_pageId+" .ct_btn",function(){
			postData();  // 提交答题
		});
		/*  回访问卷    选项绑定提示事件 */
		appUtils.preBindEvent($(_pageId+" .user_form")," .icon_radio",function(){
			validateSelect(this);
		});
	}
	function validateSelect(obj)
	{
		// 若当前点击没有选中，去除全部选中
		if(!$(obj).hasClass("checked"))
		{
			$(obj).parent().siblings().children("a").removeClass("checked");  // 选中当前答案，将其他答案标记未选择
			$(obj).parent().parent().prev("h5").css("color","#666666");	 // 红色标记恢复黑色
		}
		else
		{
			$(obj).parent().parent().prev("h5").css("color","red");  //未选择答案，则将该题标记为红色
		}
		$(obj).toggleClass("checked");
	}
	
	function destroy()
	{
		service.destroy();
	}
	
	/* 获取风险测评题库 */
	function getRiskAssessQuestions()
	{
		// 查询风险评测
		var userid = appUtils.getSStorageInfo("user_id");
		var queryTestParam = {"user_id":userid,"newFlag":1};
		service.queryRiskToc(queryTestParam,function(data){
			var errorNo = data.error_no;
			var errorInfo = data.error_info;
			if(errorNo==0 && data.results.length != 0)  // 调用成功,跳转到风险测评页面
			{
				var results = data.results;
				fengxian_sub_id = results[0]["sub_id"];
				var questionHtml = "";
				$(_pageId+" .test_fengxian").html("");
				for(var i =0; i<results.length; i++)  // 先遍历
				{
					var oneEle = results[i];
					var queid = oneEle.que_id;  // que_id	题目编号
					var type = oneEle.type;  // type	问题类型（0：单选，1：多选）
					var qname = oneEle.q_name;  // q_name	题目描述
					var str = type+"-"+queid+"-"+qname;
					var secondMap = null;
					if(!fristMap.containsKey(str))  // 若map中没有对应的问题号，则存入问题号
					{
						secondMap = new Map();
						secondMap.put(oneEle.ans_id,oneEle);
						fristMap.put(str, secondMap);	  // fristMap每一个Key对应一个问题
					}
					else
					{
						fristMap.get(str).put(oneEle.ans_id,oneEle); 
					}
				}
				var keys = fristMap.keys();
				for(var j=0; j<keys.length; j++)
				{
					var oneData  = fristMap.get(keys[j]); // 取出一个问题
					questionHtml += createRiskAccessElement(oneData,keys[j],j+1);
				}
				//把题目和答案都保存起来
                appUtils.setSStorageInfo("riskProtocolQues",questionHtml)
				$(_pageId+" .test_fengxian").html(questionHtml);
				// 当题目过多，则设置下一步按钮悬浮底部
				if($(document.body).height()<$(_pageId).height())
				{
					$(_pageId+" .fix_bot").css("position","fixed");
				}
				else
				{
					$(_pageId+" .fix_bot").css("position","absolute");
				}
				// 为选择按钮添加事件
				appUtils.bindEvent($(_pageId+" .test_fengxian .icon_radio"),function(){
					var quetype = $(this).attr("que-type");	 // 问题类型0：单选，1：多选
					var queid   = $(this).attr("id");
					if(quetype == 1)
					{
						$(this).toggleClass("checked");
					}
					else
					{
						if($(this).hasClass("checked"))
						{
							$(this).parent().parent().prev("h5").css("color","red");  // 未选择答案，则将该题标记为红色
							$(this).removeClass("checked");
						}
						else
						{
							$(_pageId+" .test_fengxian #"+queid).removeClass("checked");
							$(this).parent().parent().prev("h5").css("color","#666666");	// 题目红色标记恢复黑色
							$(this).addClass("checked");
						}
					}
					//获取所选择的投资期限invest_term  生产id=200110  测试id=200242
					if(queid=="200110"){
						var text = $(this).text();
						invest_term = text.substring(2);
					}
					//获取所选择的投资品种invest_variety  生产id=200111  测试id=200243
					if(queid=="200111"){
						var text = $(this).text();
						invest_variety = text.substring(2);
					}
					
				});
//				setDefaultAnswer();  // 设置默认的答案，默认是最低风险承受能力
				setDefaultAge(); //设置默认年龄的选项
				//getFanxiqianQuestions(); //获取反洗钱测评   在获取风险测评之后 
				getOpenConfirmData(); //获取问卷回访问题
			}
			else
			{
				layerUtils.iMsg("-1",errorInfo);
			}
		},true,true,handleTimeout);
	}

	/* 设置问题的默认答案 */
	function setDefaultAnswer()
	{
		var questionList = $(_pageId+" .test_fengxian .input_list");  // 获取所有问题的集合
		// 处理每一个问题
		questionList.each(function(){
			var markArray = new Array();
			for(var i=0;i<$(this).children("p").length;i++)
			{
				markArray.push(Number($(this).children("p").eq(i).children("a").attr("ans-mark")));
			}
			markArray.sort();  // js 的 sort 方法是在原数组的基础上进行排序
			$(this).children("p").children("a[ans-mark='"+markArray[0]+"']").addClass("checked");
		});
	}
	
	/* 设置默认年龄选项 */
	function setDefaultAge(){
		var age = getAge();
		//ans-id 是测试的值
		/*
		if(age >= 18 && age <= 30){
			$(".icon_radio[ans-id=6056]").addClass("checked");
		}else if(age <= 40){
			$(".icon_radio[ans-id=6057]").addClass("checked");
		}else if(age <= 50){
			$(".icon_radio[ans-id=6058]").addClass("checked");
		}else if(age <= 60){
			$(".icon_radio[ans-id=6059]").addClass("checked");
		}else{
			$(".icon_radio[ans-id=6060]").addClass("checked");
		}*/
		/*
		//ans-id 是生产的值*/
		if(age >= 18 && age <= 30){
			$(".icon_radio[ans-id=5492]").addClass("checked");
		}else if(age <= 40){
			$(".icon_radio[ans-id=5493]").addClass("checked");
		}else if(age <= 50){
			$(".icon_radio[ans-id=5494]").addClass("checked");
		}else if(age <= 60){
			$(".icon_radio[ans-id=5495]").addClass("checked");
		}else{
			$(".icon_radio[ans-id=5496]").addClass("checked");
		}
	}
	
	/**
	 * 创建一个问题项目
	 * @param oneData 一个问题结果集
	 * @param key 结构type+"-"+queid+"-"+qname;
	 */
	function createRiskAccessElement(oneData,key,index)
	{
		var type  = key.split("-")[0];
		var queid = key.split("-")[1];
		var qname = key.split("-")[2];
		var oneDatakeys = oneData.keys();
		var itemHtml = "";
		var itemHead = "";
		var itemElem = "";
		var str = '(<span style="color:red;">多选</span>)';
		// 问题标号
		var bgNum ="A";
		for(var i =0; i<oneDatakeys.length; i++)  // 先遍历确定有多少题
		{
			var oneElem = oneData.get(oneDatakeys[i]);
			var mark  = oneElem.mark;  // 答案分值
			var aname = oneElem.a_name;  // 答案描述
			var ansid = oneElem.ans_id;
			if(type==0) str ="(单选)";
			bgNum = changQuestionBgNum(i);
			itemElem += "<p><a href=\"javascript:void(0);\" class=\"icon_radio\" No =\""+i+"\" que-type =\""+type+"\" ans-id=\""+ansid+"\" ans-mark=\""+mark+"\" id =\""+queid+"\">"+bgNum+". "+aname+"</a></p>";
		}
		itemHead = "<h5>"+index+". "+qname+str+"</h5>";
		itemHtml = "<div class=\"test_box\">"+itemHead+"<div class=\"input_list\" id=\""+(index+"-"+queid)+"\">"+itemElem+"</div></div>";
		return itemHtml;
	}
	
	/* 提交风险评测答案 */
	function postData()
	{
		var riskCheckedAns = {};
		var keys = fristMap.keys();
		//风险测评的数据
		var oneRiskAssessData ="";	// 格式如：1_2_7|2_7_3|  问题ID_答案ID_答案分值
		//反洗钱测评的数据
		var fanxiqianData ="";	// 格式如：1_2_7|2_7_3|  问题ID_答案ID_答案分值
		
		//判断是否有未选择的风险测评
		var countNoChoice = 0; // 没有选择问题数量
		var numNoChoice  ="";  // 没有选择问题题号
		var count = 0;//计数
		for(var j=0; j<keys.length; j++)
		{
			var index = j+1;
			var queid = keys[j].split("-")[1];
			var isChoice = false;
			var describe = "";
			$(_pageId+" .test_fengxian #"+queid).each(function (){
				if($(this).hasClass("checked"))
				{
					isChoice = true;
					var ansid = $(this).attr("ans-id");
					var mark  = $(this).attr("ans-mark");
					var No = $(this).attr("No");
					if(!riskCheckedAns[queid]){
						riskCheckedAns[queid] = No;
					}else{
                    	riskCheckedAns[queid] += "-" + No;
                    }
					oneRiskAssessData +=(queid+"_"+ansid+"_"+mark+"|");
					describe += $(this).html().substring(3,$(this).html().length) + "；";
				}
			});
			describe = describe.substring(0,describe.length-1);
			switch(index){
				case 7:appUtils.setSStorageInfo("invest_date",describe);break;
				case 8:appUtils.setSStorageInfo("invest_kind",describe);break;
				case 9:appUtils.setSStorageInfo("yqsy",describe);break;
			}
			if(!isChoice)  // 没有选中 则记录未提交的题目编号
			{
				countNoChoice++;
				numNoChoice +=index+"、";
			}
		}
		if(countNoChoice>0)//您的答题尚未完成
		{
			numNoChoice=numNoChoice.substring(0,numNoChoice.length-1); // 去掉最后一个逗号
			layerUtils.iAlert("您的风险测评答题尚未完成，未完成题目编号："+numNoChoice);
			return false;
		}
		
		validateIfQuestionisFinish();
		
		var userid = appUtils.getSStorageInfo("user_id");
		appUtils.setSStorageInfo("riskCheckedAns",JSON.stringify(riskCheckedAns))
		submitFengxian(userid,oneRiskAssessData,fanxiqianData);
	}
	
	function validateIfQuestionisFinish()
	{
		var oneRiskAssessData ="";
		var countNoChoice = 0; // 没有选择问题数量
		var numNoChoice  =""; // 没有选择问题题号
		var keys = wjdcMap.keys();
		for(var j=0; j<keys.length; j++)
		{
			var queid = keys[j].split("-")[1];
			var isChoice = false;
			$(_pageId+" .radio_table dd #"+queid).each(function (){
				if($(this).hasClass("checked"))
				{
					isChoice = true;
					var ansid = $(this).attr("ans-id");
					var mark  = $(this).attr("ans-mark");
					oneRiskAssessData +=(queid+"_"+ansid+"_"+mark+"|");
				}
			});
			// 校验不规范答题
			if(!isChoice || !$(_pageId+" .radio_table:eq("+j+") dd a[ans-mark='1'] ").hasClass("checked"))
			{
				countNoChoice++;
				numNoChoice +=(j+1)+"、";
			}
		}
		if(countNoChoice>0) // 您的答题尚未完成
		{
			numNoChoice=numNoChoice.substring(0,numNoChoice.length-1); // 去掉最后一个逗号
			layerUtils.iAlert("亲！您如下答题编号：【"+numNoChoice+"】 无法通过问卷回访，请重新作答");
			return false;
		}
		return oneRiskAssessData;
	}
	/*提交风险测评  之后提交用户回访问卷*/
	function submitFengxian(userid,oneRiskAssessData,fanxiqianData){
		var submitTestParam ={
			"user_id":userid,
			"sub_id":fengxian_sub_id,
			"q_a_args":oneRiskAssessData
		};
		// 提交风险评测答案
		service.submitTestAnswer(submitTestParam,function(data){
			var errorNo = data.error_no;
			var errorInfo = data.error_info;
			if(errorNo==0 && data.results.length != 0)	//调用成功,跳转到风险测评页面
			{
				var results = data.results[0]
			//	var remark = results.remark;
				var riskdesc = results.riskdesc;
				appUtils.setSStorageInfo("riskexp",results.riskexp);
				//适当性
				appUtils.setSStorageInfo("riskmatching",results.riskmatching);
				var conMsg = "您的风险测评等级为："+riskdesc;
				var oneQuestionaireData ="";	// 格式如：1_2_7|2_7_3|  问题ID_答案ID_答案分值
				oneQuestionaireData = validateIfQuestionisFinish();
				if(!oneQuestionaireData)
				{
					return false;
				}
				var userid = appUtils.getSStorageInfo("user_id");
				var submitParam = {
						"user_id":userid,
						"q_a_args":oneQuestionaireData,
						"sub_id":huifang_sub_id,
						//这里version 作为流程修改后的提交问卷的处理方式 老流程 version不传 处理方式不变
						"version":1
				};
				$(_pageId+" .user_form h5").css("color","#666666");	// 红色标记恢复黑色
				service.submitActiveQuestions(submitParam,function(data){
					var errorNo = data.error_no;
					var errorInfo = data.error_info;
					if(errorNo==0 || errorNo== "-50195504")	 // 调用成功,跳转到风险测评页面 50195504问卷已激活，也是跳到下一步
					{
						//提交问卷回访
					//	layerUtils.iConfirm(conMsg,function(){
							redirectToNextPage();
					//	});
						function redirectToNextPage(){
							appUtils.pageInit("account/riskAssessment","account/riskAssessmentResult",{"riskdesc":riskdesc});
						}
					}
					else
					{
						layerUtils.iAlert(errorInfo, -1);
					}
				});
			}
			else
			{
				layerUtils.iMsg("-1",errorInfo);
			}
		});
	}
	
	
	/* 改变问题答案 */
	function changQuestionBgNum(num)
	{
		var bgNum ="A";
		switch(num)
		{
			case 0: bgNum = "A"; break;
			case 1: bgNum = "B"; break;
			case 2: bgNum = "C"; break;
			case 3: bgNum = "D"; break;
			case 4: bgNum = "E"; break;
			case 5: bgNum = "F"; break;
			case 6: bgNum = "G"; break;
			default: bgNum ="其它";
		}
		return bgNum;
	}

	/* 获取开户确认回访问卷 */
	function getOpenConfirmData()
	{
		var userid = appUtils.getSStorageInfo("user_id");
		$(_pageId+" .user_form").html("");
		var visitSubParam = {
				"user_id":userid,
//				"sub_id":"5000"
				"sub_id":""
		};
		// 获取回访问卷题目
		service.getVisitSub(visitSubParam,function(data){
			var errorNo   = data.error_no;
			var errorInfo = data.error_info;
			if(errorNo == 0 && data.results.length != 0)	//调用成功
			{
				var results = data.results;
				var questionHtml = "";
				huifang_sub_id = results[0].sub_id;
				for(var i =0; i<results.length; i++)  // 先遍历
				{
					var oneEle = results[i];
					var queid = oneEle.que_id;
					var type = oneEle.type;
					var qname = oneEle.q_name;
					var str = type+"-"+queid+"-"+qname;
					var secondMap = null;
					if(!wjdcMap.containsKey(str)) // 若map中没有对应的问题号，则存入问题号
					{
						secondMap = new Map();
						secondMap.put(oneEle.ans_id,oneEle);
						wjdcMap.put(str, secondMap);	// fristMap每一个Key对应一个问题
					}
					else
					{
						wjdcMap.get(str).put(oneEle.ans_id,oneEle);
					}
				}
				var keys = wjdcMap.keys();
				for(var j=0; j<keys.length; j++)
				{
					var oneData  = wjdcMap.get(keys[j]);//取出一个问题
					questionHtml += createOpenConfirmElement(oneData,keys[j],j+1);
				}
				$(_pageId+" .user_form").html(questionHtml);
				
				// 设置默认值，默认选择正确答案
				$(_pageId+" .user_form dl a[ans-mark=1]").addClass("checked");
			}
			else
			{
				layerUtils.iAlert(errorInfo);
			}
		},true,true,handleTimeout);
	}
	/**
	 * 提交 问卷回访的答案
	 */

	
	/*根据身份证号 获取用户年龄*/
	function getAge(){
		var UUserCard = appUtils.getSStorageInfo("idCardNo");
		//获取年龄 
		var myDate = new Date(); 
		var month = myDate.getMonth() + 1; 
		var day = myDate.getDate(); 
		var age = myDate.getFullYear() - UUserCard.substring(6, 10) - 1; 
		if (UUserCard.substring(10, 12) < month || UUserCard.substring(10, 12) == month && UUserCard.substring(12, 14) <= day) { 
			age++; 
		} 
		return age;
	}
	/* 创建一个问题项目 */
	function createOpenConfirmElement(oneData,key,index)
	{
		var type  = key.split("-")[0];
		var queid = key.split("-")[1];
		var qname = key.split("-")[2];
		var oneDatakeys = oneData.keys();
		var itemHtml = "";
		var itemHead = "";
		var itemElem = "";
		for(var i =0; i<oneDatakeys.length; i+=3) // 先遍历确定有多少题
		{
			var oneElem = oneData.get(oneDatakeys[i]);
			var mark  = oneElem.mark;
			var aname = oneElem.a_name;
			var ansid = oneElem.ans_id;
			itemElem += "<dd><a href=\"javascript:;\" class=\"icon_radio\" que-choice='0' que-type ='"+type+"' ans-id='"+ansid+"' ans-mark=\""+mark+"\" id ='"+queid+"'>"+aname+"</a></dd>";
			if(oneDatakeys.length >= 2 ) // 取第二条数据
			{
				var oneEleTwo = oneData.get(oneDatakeys[i+1]);
				var markTwo  = oneEleTwo.mark;
				var anameTwo = oneEleTwo.a_name;
				var ansidTwo = oneEleTwo.ans_id;
				itemElem += "<dd><a href=\"javascript:;\" class=\"icon_radio\" que-choice='1' que-type ='"+type+"' ans-id='"+ansidTwo+"' ans-mark=\""+markTwo+"\" id ='"+queid+"'>"+anameTwo+"</a></dd>";
				if(oneDatakeys.length >= 3 )  // 取第三条数据
				{
					var oneEleThree = oneData.get(oneDatakeys[i+2]);
					var markThree  = oneEleThree.mark;
					var anameThree = oneEleThree.a_name;
					var ansidThree = oneEleThree.ans_id;
					itemElem += "<dd><a href=\"javascript:;\" class=\"icon_radio\" que-choice='1' que-type ='"+type+"' ans-id='"+ansidThree+"' ans-mark=\""+markThree+"\" id ='"+queid+"'>"+anameThree+"</a></dd>";
				}
			}
		}
		itemHead = "<h5 class=\"title\">"+index+"、 "+qname+"</h5>";
		if(queid == "92"){
			itemHead+= info;
		}
		itemHtml = itemHead+"<dl class=\"radio_table\" id="+queid+">"+itemElem+"</dl>";
		return itemHtml;
	}
	

	function getInfo(){
		var branchname = appUtils.getSStorageInfo("branchname"),
		custname = appUtils.getSStorageInfo("custname"),
		mobileNo = appUtils.getSStorageInfo("mobileNo"),
		addr = appUtils.getSStorageInfo("addr"),
		branchno =  appUtils.getSStorageInfo("branchno"),
		idCardNo = appUtils.getSStorageInfo("idCardNo");
		info = "&nbsp&nbsp您的姓名："+custname+"<br/>"
				+"&nbsp&nbsp身份证号码："+idCardNo+"<br/>"
				+"&nbsp&nbsp联系电话："+mobileNo+"<br/>"
				+"&nbsp&nbsp地址："+addr+"<br/>"
				+"&nbsp&nbsp申请开户营业部："+branchname+"<br/>" 
				+"&nbsp&nbsp开户营业部编号："+branchno+"<br/>";
	}
	
	/* 处理请求超时 */
	function handleTimeout()
	{
		layerUtils.iConfirm("请求超时，是否重新加载？",function(){
			getRiskAssessQuestions();  // 再次风险测评题目
		});
	}
	
	var riskAssessment = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	module.exports = riskAssessment;
});