/**
* 风险测评结果
*/
define("project/scripts/account/riskAssessmentResult",function(require,exports,module){
	var appUtils = require("appUtils"),
		global = require("gconfig").global,
		layerUtils = require("layerUtils"),
		service = require("serviceImp").getInstance(),  //业务层接口，请求数据
		_pageId = "#account_riskAssessmentResult";
	
	function init()
	{
		//设置按钮显示提示文字
		if(appUtils.getSStorageInfo("openChannel") == "change")
		{
			if(appUtils.getSStorageInfo("finance") == "finance")
			{
				$(_pageId+" .fix_bot .ct_btn a").html("继续开户 >");  // 理财户
			}
			else
			{
				$(_pageId+" .fix_bot .ct_btn a").html("继续转户 >");  // 转户
			}
		}
		else
		{
			$(_pageId+" .fix_bot .ct_btn a").html("继续开户 >");  // 新开户
		}
		
		// 只有从 riskAssessment 跳转过来时，才设置页面的填充数据
		if(appUtils.getSStorageInfo("_prePageCode") == "account/riskAssessment")
		{
		//	var remark  = appUtils.getPageParam("remark");  //风险等级
			var riskdesc = appUtils.getPageParam("riskdesc"); //风险等级描述
			var showStr = riskdesc;
			//var fanxiqianMark  = appUtils.getPageParam("fanxiqianMark");  //反洗钱等级
			//var fanxiqianDesc = appUtils.getPageParam("fanxiqianDesc"); //反洗钱等级描述
			// 清空原有内容
			$(_pageId+" .fengxian").text("");
			if(!!showStr && showStr.indexOf("（") > 0){
				showStr = showStr.substring(0,showStr.indexOf("（"))
			}
			$(_pageId+" .fengxian").append(showStr);
			var invest_date = appUtils.getSStorageInfo("invest_date")
			var invest_kind = appUtils.getSStorageInfo("invest_kind")
			var yqsy = appUtils.getSStorageInfo("yqsy")
			$(_pageId+" #invest_date").text(invest_date)
			$(_pageId+" #invest_kind").text(invest_kind)
			$(_pageId+" #yqsy").text(yqsy)
			//$(_pageId+" .fanxiqian").text("");
			//$(_pageId+" .fanxiqian").append(fanxiqianDesc);
		}
		if(appUtils.getSStorageInfo("isReadGzh")){
			$(_pageId+" .rule_check .icon_check").addClass("checked");
		}else{
			$(_pageId+" .rule_check .icon_check").removeClass("checked");
		}
	}
	
	function bindPageEvent()
	{
		/* 绑定返回 */
		appUtils.bindEvent($(_pageId+" .header .icon_back"),function(){
			appUtils.clearSStorage("isReadGzh");
			appUtils.pageInit("account/riskAssessmentResult","account/riskAssessment",{});
		});
		
		// 重新测评绑定事件
		appUtils.bindEvent($(_pageId+" #reTest"),function(){
			appUtils.clearSStorage("isReadGzh");
			appUtils.pageInit("account/riskAssessmentResult","account/riskAssessment",{});
		});
		
		/**
		 * 9.1
		 * 风险测评结果页面进入问卷回访页面
		 */
		appUtils.bindEvent($(_pageId+" .ct_btn"),function(){
		    if(!$(_pageId+" .rule_check .icon_check").hasClass("checked")){
           	    layerUtils.iAlert('尊敬的投资者，请您仔细阅读并同意'+$(_pageId+" #protocol").text());
                return false;
            }else{
            	alertFunction();
			}
		});
		
		/* 绑定签署协议*/
		appUtils.bindEvent($(_pageId+" .rule_check .icon_check"),function(){
			if(!!appUtils.getSStorageInfo("isReadGzh")){
				$(this).toggleClass("checked"); //  切换勾选样式
			}else{
				layerUtils.iAlert("尊敬的投资者，请您仔细阅读并同意《投资者风险承受能力评估结果告知书》")
			}
		});
		
		appUtils.bindEvent($(_pageId+" #protocol"), function () {
    		appUtils.pageInit("account/riskAssessmentResult","account/riskProtocol",{});
    	})
	}
	
	function alertFunction(){
		var param = {
			"user_id_new":appUtils.getSStorageInfo("user_id"),
			"risk_level":appUtils.getSStorageInfo("riskexp"),
			"riskmatching":appUtils.getSStorageInfo("riskmatching")
		}
		service.req602021(param,function(data){
			var errorNo = data.error_no;
			var errorInfo = data.error_info;
			if(errorNo==0)
			{
//				layerUtils.iAlert(data.results[0].risk_prompt, -1 ,function(){
//					if(param.riskmatching == "0"){//风险标识: 0:最低风险类别    1：风险等级不匹配   2：风险等级匹配
//						return false;
//					}else{
//						checkRiskLevel();
//					}
//				});
				if(param.riskmatching == "0"){//风险标识: 0:最低风险类别    1：风险等级不匹配   2：风险等级匹配
					layerUtils.iAlert(data.results[0].risk_prompt, -1);
					return false;
				}else{
					appUtils.pageInit("account/riskAssessmentResult","account/tips",{"risk_prompt":data.results[0].risk_prompt});
				}
			}
			else
			{
				layerUtils.iAlert(errorInfo, -1);
			}
		});
	}

	function checkRiskLevel(){
		var param = {
			"user_id":appUtils.getSStorageInfo("user_id"),
			"product_level":"1",
			"risk_level":appUtils.getSStorageInfo("riskexp"),
			"riskmatching":appUtils.getSStorageInfo("riskmatching")
		}
		service.req502039(param,function(data){
			var errorNo = data.error_no;
			var errorInfo = data.error_info;
			if(errorNo==0)	 // 调用成功,跳转到风险测评页面 50195504问卷已激活，也是跳到下一步
			{
				appUtils.pageInit("account/riskAssessmentResult","account/accountResult",{});
			}
			else
			{
				layerUtils.iAlert(errorInfo, -1);
			}
		});
	}
	
	function destroy(){}
	
	var riskAssessmentResult = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	module.exports = riskAssessmentResult;
});