/**
 * 选择营业部
 */
define("project/scripts/account/selDepartment",function(require, exports, module){ 
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
	service = require("serviceImp").getInstance(),  //业务层接口，请求数据
	global = require("gconfig").global,
	layerUtils = require("layerUtils"),
	shellPlugin = require("shellPlugin"),
	provinceList = "",  //省份
	cityList = "",  //城市
	branchList = "",  //营业部
	commissionList = "",  //佣金套餐
	localPro = "",  // 本地省份
	localCity = "",  // 本地城市
	localBranch = "",  // 本地营业部
	branchParam={"branchno" : "", "commission" : ""},  //营业部编号
	recommendname="",//推荐人姓名
	hasbranch = true,  // 判断定位的城市是否拥有营业部
	isReferee = true,  //判断推荐人是否填写正确
	_pageId = "#account_selDepartment";
	var branchIDList = new Array();  // 当前渠道营业部ID集合
	var cityIDList = new Array();    // 当前渠道城市ID集合
	var provinceIDList = new Array();  // 当前渠道省份ID集合
	var is_manual_input_jjr_dm = "2"; // 是否允许手动输入经纪人代码
	var branchNumber;
	var branchNameTfej = "成都天府二街营业部(网络营业部)";
	
	/* 私有业务模块的全局变量 end */

	function init()
	{
		initPage();  // 初始化页面
	}

	function bindPageEvent()
	{
		/* 绑定返回 */
		appUtils.bindEvent($(_pageId+" .header .icon_back"),function(){
			appUtils.pageBack();
		});

		/* 绑定退出按钮*/
//		appUtils.bindEvent($(_pageId+" .header .icon_close"),function(){
//		require("utils").layerTwoButton("退出系统？","确认","取消",function(){
//		require("shellPlugin").callShellMethod("closeAppPlugin",null,null);  // 退出程序
//		},
//		function(){return false;});
//		});

		/* 点击页面其他元素隐藏下拉列表 */
		appUtils.bindEvent($(_pageId),function(e){
			$(_pageId+" .sel_list").slideUp("fast");	// 隐藏下拉列表
			e.stopPropagation();	// 阻止冒泡
		});

		/* 绑定清除推荐人*/
		appUtils.bindEvent($(_pageId+" #del_recommend"),function(e){
			if (is_manual_input_jjr_dm != "1") {
				reBind();
			}
			$(_pageId+" #writeInfo_referee").val("");
			$(_pageId+" #sel_recommend").text("请选择推荐人（选填）");
			recommendname="";
			e.stopPropagation();	// 阻止冒泡
		});

		/* 推荐人 失去焦点是校验 提示*/
		appUtils.bindEvent($(_pageId+" #writeInfo_referee"),function(e){
			var value = $(this).val();
			value = manualUppercase(value);
			value = value.replace(/[^\A-Z\0-9]/g,'');
			$(this).val(value);
			if(value.length != 12){
                                isReferee = false;
				recommendname="";
				$(_pageId+" #sel_recommend").text("请选择推荐人（选填）");
				reBind();
			}
			if(value == ""){
				isReferee = true;
			}
		},"blur");
		
	}
	//小写转大写
	function manualUppercase(s) {
	    s = s.replace(/[a-z]/g, function(ch) {return String.fromCharCode(ch.charCodeAt(0) & ~32);});
	    return s;
	}
	
	function bindEvents(branchNum) {
		branchNumber = branchNum;
		var isTip = true;
		if (1 == branchNum) {
			$(_pageId+" .sel_province").removeClass("sel_text").addClass("sel_text_fixed");
			$(_pageId+" .sel_city").removeClass("sel_text").addClass("sel_text_fixed");
			$(_pageId+" .sel_branch").removeClass("sel_text").addClass("sel_text_fixed");
			if (is_manual_input_jjr_dm != "1") {
				$(_pageId+" .input_form").css("visibility", "hidden");
			} else {
				$(_pageId+" #sel_recommend").removeClass("sel_text").addClass("sel_text_fixed");
			
				/* 推荐人查询*/
				appUtils.bindEvent($(_pageId+" #query_recommend"),function(e){
					var recommendno = $(_pageId+" #writeInfo_referee").val();//推荐人编号
					recommendno = manualUppercase(recommendno);
					if(recommendno.length != 12){
						layerUtils.iMsg(-1,"推荐人长度为12位，请检查推荐人信息是否正确！");
						return false;
					}else{
						checkBroker(recommendno);
					}
				});
			}
			isTip = false;
		} else {
			/* 绑定选择省份 */
			appUtils.bindEvent($(_pageId+" .mobile_form .sel_province"),function(e){
				$(_pageId+" .city").hide();  //隐藏城市列表
				$(_pageId+" .branch").hide();  //隐藏营业部列表
				$(_pageId+" .recommend").hide();  //隐藏推荐人列表
//				$(_pageId+" .commission").hide();  //隐藏佣金列表
				$(_pageId+" .province ul li").removeClass("active");
				$(_pageId+" .province").slideToggle("fast");	 // 显示选择省份的下拉列表
				e.stopPropagation();	// 阻止冒泡
			});
			
			/* 绑定选择城市 */
			appUtils.bindEvent($(_pageId+" .mobile_form .sel_city"),function(e){
				$(_pageId+" .province").hide();  //隐藏省份列表
				$(_pageId+" .branch").hide();  //隐藏营业部列表
				$(_pageId+" .recommend").hide();  //隐藏推荐人列表
//				$(_pageId+" .commission").hide();  //隐藏佣金列表
				$(_pageId+" .city ul li").removeClass("active");
				$(_pageId+" .city").slideToggle("fast");	// 显示选择城市的下拉列表
				e.stopPropagation();	// 阻止冒泡
			});
			
			/* 绑定选择营业部 */
			appUtils.bindEvent($(_pageId+" .mobile_form .sel_branch"),function(e){
				$(_pageId+" .province").hide();  //隐藏省份列表
				$(_pageId+" .city").hide();  //隐藏城市列表
				$(_pageId+" .recommend").hide();  //隐藏推荐人列表
//				$(_pageId+" .commission").hide();  //隐藏佣金列表
				$(_pageId+" .branch ul li").removeClass("active");
				$(_pageId+" .branch").slideToggle("fast");	// 显示选择营业厅的下拉列表
				e.stopPropagation();	// 阻止冒泡
			});
			
			/* 绑定选择推荐人*/
			appUtils.bindEvent($(_pageId+" #sel_recommend"),function(e){
				$(_pageId+" .province").hide();  //隐藏省份列表
				$(_pageId+" .city").hide();  //隐藏城市列表
				$(_pageId+" .branch").hide();
				$(_pageId+" .recommend ul li").removeClass("active");
				$(_pageId+" .recommend").slideToggle("fast");	// 显示选择营业厅的下拉列表
				e.stopPropagation();	// 阻止冒泡
			});
			
			/* 推荐人查询*/
			appUtils.bindEvent($(_pageId+" #query_recommend"),function(e){
				var recommendno = $(_pageId+" #writeInfo_referee").val();//推荐人编号
				recommendno = manualUppercase(recommendno);
				if(recommendno.length != 12){
					layerUtils.iMsg(-1,"推荐人长度为12位，请检查推荐人信息是否正确！");
					return false;
				}else{
					checkBroker(recommendno);
				}
			});
			
			if (branchNum > 1 && is_manual_input_jjr_dm != "1") {
				$(_pageId+" .input_form").css("visibility", "hidden");
			}
		}
		
		/* 绑定下一步 */
		appUtils.bindEvent($(_pageId+" .fix_bot .ct_btn"),function(){
			var province_name =$(_pageId+" .mobile_form .sel_province").text();
			var city_name =$(_pageId+" .mobile_form .sel_city").text();
			var branch_name = $(_pageId+" .mobile_form .sel_branch").text();
			appUtils.setSStorageInfo("branchno",branchParam.branchno);  // 营业部id保存在session
			var recommendno = $(_pageId+" #writeInfo_referee").val();//推荐人编号
			recommendno = manualUppercase(recommendno);
			var isRecommendNoNull = false;
			//判断推荐人是否填写正确
			if($(_pageId+" #writeInfo_referee").val().length!=0){
				if($(_pageId+" #writeInfo_referee").val().length==12 ){
					if(!isReferee){
						layerUtils.iMsg(-1,"推荐人长度为12位，请检查推荐人信息是否正确！");
						return false;
					}
				}else{
					layerUtils.iMsg(-1,"推荐人长度为12位，请检查推荐人信息是否正确！");
					return false;
				}
			} else {
				isRecommendNoNull = true;
			}
			if(province_name == "请选择省份")
			{
				layerUtils.iMsg(-1,"请先选择开户省份部");
				return false;
			}
			if(city_name == "请选择城市")
			{
				layerUtils.iMsg(-1,"请先选择开户城市");
				return false;
			}
			if(branch_name == "请选择营业部")
			{
				layerUtils.iMsg(-1,"请选择开户营业部");
				return false;
			}

			if (!isRecommendNoNull) {
				// 填了推荐人
				if (-1 != global.serverPath.indexOf("wxtest")) {
					// 测试环境
					next(recommendno,branch_name,isTip);
				} else {
					layerUtils.iLoading(true);
					judgeRecommendAndBranchIsValid(recommendno,branch_name,isTip);
				}
			} else {
				next(recommendno,branch_name,isTip);
			} 
			
		});
	}
	
	//下一步
	function next(recommendno,branch_name,isTip){
		//最后确认 开户营业部
		var conMsg = "";
		if(recommendname!=""){
			conMsg += "您的推荐人为："+recommendname +"<br>"; //推荐人
		}
		conMsg += "您选择的开户营业部为："+branch_name;
		
		if (isTip) {
			layerUtils.iConfirm(conMsg,function(){
				setLocalRecommend(recommendno);//保存推荐人到本地手机
				appUtils.setSStorageInfo("recommendno",recommendno);  // 推荐人编号保存在session
				appUtils.pageInit("account/selDepartment","account/uploadPhoto",branchParam);
				appUtils.clearSStorage("idInfo");  // 清除完成身份证上传步骤标记
			});
		} else {
			setLocalRecommend(recommendno);//保存推荐人到本地手机
			appUtils.setSStorageInfo("recommendno",recommendno);  // 推荐人编号保存在session
			appUtils.pageInit("account/selDepartment","account/uploadPhoto",branchParam);
			appUtils.clearSStorage("idInfo");  // 清除完成身份证上传步骤标记
		}
	}

	function judgeRecommendAndBranchIsValid(recommendno, branch_name, isTip){
		var param = {
				"user_id":appUtils.getSStorageInfo("user_id"),
				"brokercode":recommendno
		};
		
		service.queryBrokerInfo(param,function(data){
			layerUtils.iLoading(false);
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == 0 ){
				var results = data.results;
				if(results!=null&&results.length>0) {
					var _branchno = results[0].dwbh;
					if (_branchno == branchParam.branchno) {
						// 经纪人所在营业部与填写营业部一致
						next(recommendno,branch_name,isTip);
					} else {
						layerUtils.iAlert("您选择营业部无此推荐人，请检查是否输入错误。");
					}
				} else {
					layerUtils.iAlert("无此推荐人，请检查推荐人代码输入是否正确！");
				}
			} else {
				layerUtils.iAlert("无此推荐人，请检查推荐人代码输入是否正确！");
			}
		},false,true,handleQueryBrokerInfoTimeout);
	}

	function handleQueryBrokerInfoTimeout() {
		layerUtils.iLoading(false);
	}

	function destroy()
	{
		service.destroy();
	}

	/* 初始化页面 */
	function initPage()
	{
		cleanPageElement(); // 清理页面元素值
//		var Commission = appUtils.getSStorageInfo("commission");  // 用户已选佣金id
//		var Commission_name = appUtils.getSStorageInfo("commissionname");  // 用户已选佣金值
		var Branch_no = appUtils.getSStorageInfo("branchno"); // 用户已选营业部id
		var Branch_name = appUtils.getSStorageInfo("branchname");  // 用户已选营业部名称
		var Province_name = appUtils.getSStorageInfo("provincename");  // 用户已选省份
		var City_name = appUtils.getSStorageInfo("cityname");  // 用户已选城市
		if ("qdsw" == global.open_channel) {
			is_manual_input_jjr_dm = appUtils.getSStorageInfo("is_manual_input_jjr_dm");
		}
		
//		var recommendno = appUtils.getSStorageInfo("recommendno");//推荐人编号 
//		if(recommendno){
//			$(_pageId+" #writeInfo_referee").val(recommendno);
//		}
		
		//  用户如果已选择了营业部，就不需要定位
//		if(Province_name && City_name && Branch_name)
//		{
//			hasbranch = true;
//			localPro = Province_name;
//			localCity = City_name;
//			localBranch = Branch_name;
//			branchParam.branchno = Branch_no;
//			$(_pageId+" .sel_province").html(Province_name);
//			$(_pageId+" .sel_city").html(City_name);
//			$(_pageId+" .sel_branch").html(Branch_name);
//			/*if(Commission)
//			{
//				branchParam.commission = Commission;
//				$(_pageId+" .sel_commission").html(Commission_name);
//			}*/
//			getBranch();  // 获取营业部List
//		}
//		else
//		{
//			getPosition();  // 进行地理定位
//		}
		
		// 不定位，直接获取所有省、市、营业部
		getBranch();
		
		sendStatisticInfo();
	}
	
	function sendStatisticInfo() {
		var qdId = "";
		if ("qdsw" == global.open_channel) {
			qdId = appUtils.getSStorageInfo("qdid");
			if (qdId == null) {
				qdId = "";
			}
		} else {
			qdId = global.open_channel;
		}  

		var versionName = "";
		shellPlugin.callShellMethod("getVersionPlugin", function(data) {
					versionName = data.versionName;
				});
		
		shellPlugin.callShellMethod("getOsVersionPlugin",function(data){
			var parm = {
					"userid":appUtils.getSStorageInfo("user_id"),
					"user_step" :'login',
					"open_channel" : qdId,
					"open_source" :  require("gconfig").global.open_source,
					"machine_mobile" :  data.mobileModel,
					"machine_brand" :   data.mobileBrand,
					"machine_os" :      data.mobileOs,
					"kh_version" : versionName
			};
			service.logOperChannel(parm);
		});
	}

	/* 定位本地地址 */
	function getPosition()
	{
		var positionSign = "";
		layerUtils.iAlert("正在定位中，请稍后....", -1, function(){
			layerUtils.iLayerClose();
			positionSign = "1";
			if(positionSign == "1"){
				getBranch();  // 获取营业部List
			}
			//cleanPageElement(); // 清理页面元素值
		},"取消");
		// 获取ip地址
		shellPlugin.callShellMethod("getIpMacPLugin",function(data){
			var ip = data.split("|")[1];
			// 获取定位省份和城市
			service.getProvCity({"ip":ip}, function(data){
				layerUtils.iLayerClose();  // 关闭定位提示
				if(positionSign == ""){
					positionSign = "2";
				}
				if(positionSign == "2"){
					if(data.error_no == 0 && data.results.length !=0 )
					{
						hasbranch = false;  
						localPro = data.results[0].province;		
						localCity = data.results[0].city;		
						$(_pageId+" .sel_province").text(localPro);	  
						$(_pageId+" .sel_city").text(localCity);	  
					}
					else
					{
						hasbranch = true;  
//						layerUtils.iMsg(-1,"定位附近营业部失败，请您手动选择", 5);
					}
					getBranch();  // 获取营业部List
				}
			},false,false);
		});
	}

	/* 获取营业部List */
	function getBranch()
	{
		service.queryBranch({},function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no=="0" && data.dsName)
			{
				provinceList = data.provinceList; //省份集合
				cityList = data.cityList;	//城市集合
				branchList = data.branchList;	//营业部集合
//				commissionList = data.commissionList;	//佣金集合
				
				//非扫码渠道，无经纪人，营业部固定为配置好的
				queryChannelInfo();
			}
			else
			{
				layerUtils.iMsg(-1,"营业部获取失败");  //提示错误信息
			}
		},true,true,handleTimeout);
	}
	
	function fillAllList() {
		var plen = provinceList.length;
		var pro_str = "", provinceno = "", provincename = "";
		// 遍历省份集合
		for(var i=0; i<plen; i++)
		{
			provinceno = provinceList[i].provinceno; // 省份id
			provincename = provinceList[i].provincename;  // 省份名称
			pro_str += "<li pid='"+provinceno+"'><span>"+provincename+"</span></li>";
		}
		$(_pageId+" .province ul").html(pro_str);  // 填充省份下拉框
		bindProvince();  //点击省份
		// 走标准流程，省市要显示
		$($(_pageId+" .mobile_form").children("div").get(0)).css("display", "block");
		$($(_pageId+" .mobile_form").children("div").get(1)).css("display", "block");
	}
	
	/* 根据手机号码查询渠道信息 */
	function queryChannelInfo() {
		var qdId = "";
		if ("qdsw" == global.open_channel) {
			qdId = appUtils.getSStorageInfo("qdid");
		} else {
			qdId = global.open_channel;
		} 
		
		if (qdId != null && qdId.length > 0) {
			var parm = {
					"phone":appUtils.getSStorageInfo("mobileNo"),
					"operatetype" : "A",  // 根据手机号码获取渠道营业部
					"qd_bh" : qdId
				};
			
			service.queryChannelInfoNewByChannel(parm,function(data){
				var error_no = data.error_no;
				var error_info = data.error_info;
				if(error_no=="0"){
					var results = data.results;
					var len = results.length;
					if(len > 0){
						isReferee = true;
						recommendname = "";
						if (len == 1) {
							// 只有一个营业部，省、市、营业部选项全部固定不可选
							var branchId = results[0].yyb_dm.trim(); // 营业部编号
							var branchName = results[0].yyb_name.trim(); // 营业部名称
							if (branchId == "7320") {
								//天府二街营业部
								branchName = branchNameTfej;
							}
							branchIDList.push(branchId);
							bindEvents(len);
							autoFill(branchId, false);
						} else {
							var branch_str = "", city_str = "", pro_str = "";
							
							// 获取当前所有可选营业部ID，名称
							for (var i = 0; i < len; i++) {
								var branchId = results[i].yyb_dm.trim(); // 营业部编号
								var branchName = results[i].yyb_name.trim(); // 营业部名称
								if (branchId == "7320") {
									//天府二街营业部
									branchName = branchNameTfej;
								}
								branch_str += "<li bid='" + branchId + "'><span>" + branchName + "</span></li>";
								branchIDList.push(branchId);
							}
							
							// 获取当前所有可选营业部对应的城市ID
							var branchListLen = branchList.length;
							for (var i = 0; i < branchListLen; i++) {
								var branchCode = branchList[i].branchcode;
								if (-1 != branchIDList.indexOf(branchCode)) {
									var cid = branchList[i].cityno;
									if (-1 == cityIDList.indexOf(cid)) {
										cityIDList.push(cid);
									}
								}
							}
							
							// 根据城市ID获取城市名称，记录所在省ID
							var cityListLen = cityList.length;
							for (var j = 0; j < cityListLen; j++) {
								if (-1 != cityIDList.indexOf(cityList[j].cityno)) {
									if (-1 == provinceIDList.indexOf(cityList[j].provincenno)) {
										provinceIDList.push(cityList[j].provincenno);
									}
									
									city_str += "<li cid='" + cityList[j].cityno + "'><span>" + cityList[j].cityname + "</span></li>";
								}
							}
							
							// 根据省ID获取省名称
							var provinceListLen = provinceList.length;
							for (var i = 0; i < provinceListLen; i++) {
								if (-1 != provinceIDList.indexOf(provinceList[i].provinceno)) {
									pro_str += "<li pid='" + provinceList[i].provinceno + "'><span>" + provinceList[i].provincename + "</span></li>";
								}
							}
							
							bindEvents(len);
							$(_pageId+" .branch ul").html(branch_str);  // 填充对应城市的营业部
							$(_pageId+" .city ul").html(city_str);  // 填充城市下拉框
							$(_pageId+" .province ul").html(pro_str);  // 填充省份下拉框
							bindFixedProvince();
							bindFixedCity();
							bindFixedBranch();
						}
					} else {
						// 没有配置营业部，走标准流程
						bindEvents(0);
						fillAllList();
					}
				} else {
					layerUtils.iMsg(-1,"营业部获取失败");
//					bindEvents(0);
//					fillAllList();
				}
			},true,true,handleQueryChannelInfoTimeout);
		} else {
			// 没有获取到渠道记录，走标准流程
			bindEvents(0);
			fillAllList();
		}
	}
	
	function handleQueryChannelInfoTimeout()
	{
		layerUtils.iConfirm("请求超时，是否重新加载？",function(){
			queryChannelInfo();
		});
//		bindEvents(0);
//		fillAllList();
	}
	
	/* 绑定选择推荐人li*/
	function bindRecommend(){
		appUtils.bindEvent($(_pageId+" .recommend ul li"),function(e){
			var recommendName = $(this).attr("recommendName");//姓名
			var recommendno = $(this).attr("recommendno");//经纪人代码
			var dwbh = $(this).attr("dwbh");//单位名称
			$(this).addClass("active").siblings().removeClass("active");
			$(_pageId+" #writeInfo_referee").val(recommendno);
			$(_pageId+" #sel_recommend").text(recommendName);
			recommendname = recommendName ;
			autoFill(dwbh, true);
			isReferee = true;
			$(_pageId+" .recommend").slideUp("fast");	//隐藏下拉框
			e.stopPropagation();	// 阻止冒泡
		});	
	}
	
	/* 处理请求超时 */
	function handleTimeout()
	{
		layerUtils.iConfirm("请求超时，是否重新加载？",function(){
			getBranch();  // 再次获取营业部
		});
	}

	/* 选中省份事件处理 */
	function bindProvince()
	{
		appUtils.bindEvent($(_pageId+" .province ul li"),function(e){
			var pid = $(this).attr("pid");
			$(this).addClass("active").siblings().removeClass("active");
			var provincename = $(this).text();  //当前选中省份的值
			var sel_pname = $(_pageId+" .sel_province").text();  //上一次选中省份的值
			$(_pageId+" .sel_province").text(provincename);	  //将选中值赋给选择框
			appUtils.setSStorageInfo("provincename",provincename);
			$(_pageId+" .province").slideUp("fast");	//隐藏下拉框
			//再次点击相同省份,下级菜单不改变，否则重置
			if(provincename != sel_pname)   
			{
				$(_pageId+" .sel_city").text("请选择城市");
				$(_pageId+" .sel_branch").text("请选择营业部");
				$(_pageId+" .sel_commission").text("请选择佣金套餐");
				$(_pageId+" .branch ul").html("");
				$(_pageId+" .commission ul").html("");
			}
			var provincenno = "";  //省份ID
			var city_str = "";
			//选中省份立即填充相应城市
			for(var i=0; i<cityList.length; i++)
			{
				provincenno = cityList[i].provincenno;
				cityno = cityList[i].cityno;
				cityname = cityList[i].cityname;
				if(pid == provincenno)  //填充当前省份下的城市列表
				{
					city_str+= "<li cid='"+cityno+"'><span>"+cityname+"</span></li>";
				}
			}
			$(_pageId+" .city ul").html(city_str);  //填充城市下拉框
			e.stopPropagation();	// 阻止冒泡
			bindCity();  //点击城市
		});
	}
	
	function bindFixedProvince()
	{
		appUtils.bindEvent($(_pageId+" .province ul li"),function(e){
			var pid = $(this).attr("pid");
			$(this).addClass("active").siblings().removeClass("active");
			var provincename = $(this).text();  //当前选中省份的值
			var sel_pname = $(_pageId+" .sel_province").text();  //上一次选中省份的值
			$(_pageId+" .sel_province").text(provincename);	  //将选中值赋给选择框
			appUtils.setSStorageInfo("provincename",provincename);
			$(_pageId+" .province").slideUp("fast");	//隐藏下拉框
			//再次点击相同省份,下级菜单不改变，否则重置
			if(provincename != sel_pname)   
			{
				$(_pageId+" .sel_city").text("请选择城市");
				$(_pageId+" .sel_branch").text("请选择营业部");
				$(_pageId+" .branch ul").html("");
			}
			fillFixedCity(pid);
			e.stopPropagation();	// 阻止冒泡
		});
	}

	/* 选中城市事件绑定 */
	function bindCity()
	{
		appUtils.bindEvent($(_pageId+" .city ul li"),function(e){
			var cid = $(this).attr("cid");
			$(this).addClass("active").siblings().removeClass("active");
			var cityname = $(this).text();  //当前选择城市的值
			var sel_cname = $(_pageId+" .sel_city").text();  //上次选择城市的值
			$(_pageId+" .sel_city").text(cityname);	  //选中值赋给选择框
			appUtils.setSStorageInfo("cityname",cityname);
			$(_pageId+" .city").slideUp("fast");	//隐藏下拉框
			//再次点击相同城市,下级菜单不改变，否则重置
			if(sel_cname != cityname)	 
			{
				$(_pageId+" .sel_branch").text("请选择营业部");
				$(_pageId+" .sel_commission").text("请选择佣金套餐");
				$(_pageId+" .commission ul").html("");
			}
			//选中城市立即填充相应营业部
			var cityno = "";  //城市ID
			var branch_str = "";
			for(var i=0; i<branchList.length; i++)
			{
				cityno = branchList[i].cityno;
				branchcode = branchList[i].branchcode;
				branchname = branchList[i].branchname;
				if(cid == cityno)  //填充当前城市下的营业部列表
				{
					branch_str+= "<li bid='"+branchcode+"'><span>"+branchname+"</span></li>";
				}
			}
			$(_pageId+" .branch ul").html(branch_str);  //填充营业部下拉框
			e.stopPropagation();	// 阻止冒泡
			bindBranch();  //点击营业部
		});
	}
	
	function bindFixedCity()
	{
		appUtils.bindEvent($(_pageId+" .city ul li"),function(e){
			var cid = $(this).attr("cid");
			$(this).addClass("active").siblings().removeClass("active");
			var cityname = $(this).text();  //当前选择城市的值
			var sel_cname = $(_pageId+" .sel_city").text();  //上次选择城市的值
			$(_pageId+" .sel_city").text(cityname);	  //选中值赋给选择框
			appUtils.setSStorageInfo("cityname",cityname);
			$(_pageId+" .city").slideUp("fast");	//隐藏下拉框
			//再次点击相同城市,下级菜单不改变，否则重置
			if(sel_cname != cityname)	 
			{
				$(_pageId+" .sel_branch").text("请选择营业部");
				
				var provinceno = "";
				var provincename = "";
				var provinceListLen = provinceList.length;
				var cityListLen = cityList.length;
				
				for (var i = 0; i < cityListLen; i++) {
					if (cid == cityList[i].cityno) {
						provinceno = cityList[i].provincenno;
						break;
					}
				}
				
				for (var i = 0; i < provinceListLen; i++) {
					if (provinceno == provinceList[i].provinceno) {
						provincename = provinceList[i].provincename;
						break;
					}
				}
				
				$(_pageId+" .sel_province").text(provincename);
				appUtils.setSStorageInfo("provincename",provincename);
			}
			//选中城市立即填充相应营业部
			fillFixedBranch(cid);
			e.stopPropagation();	// 阻止冒泡
		});
	}
	
	function fillFixedCity(provinceId) {
		var city_str = "";
		var cityListLen = cityList.length;

		for (var i = 0; i < cityListLen; i++) {
			if (provinceId == cityList[i].provincenno
				&& -1 != cityIDList.indexOf(cityList[i].cityno)) {
				city_str += "<li cid='" + cityList[i].cityno +"'><span>" + cityList[i].cityname + "</span></li>";
			}
		}
		
		$(_pageId+" .city ul").html(city_str);  // 填充城市下拉框
		
		bindFixedCity(); 
	}
	
	function fillFixedBranch(cityId) {
		var branch_str = "";
		var branchListLen = branchList.length;
		
		for (var i = 0; i < branchListLen; i++) {
			if (cityId == branchList[i].cityno
				&& -1 != branchIDList.indexOf(branchList[i].branchcode)) {
				branch_str += "<li bid='" + branchList[i].branchcode + "'><span>" + branchList[i].branchname + "</span></li>";
			}
		}
		
		$(_pageId+" .branch ul").html(branch_str);  // 填充对应城市的营业部
		
		bindFixedBranch();  
	}

	/* 选中营业部事件绑定*/
	function bindBranch()
	{
		appUtils.bindEvent($(_pageId+" .branch ul li"),function(e){
			var bid = $(this).attr("bid");
			$(this).addClass("active").siblings().removeClass("active");
			branchParam.branchno = bid;
			var branchname = $(this).text();  //当前选中营业部的值
			var sel_bname = $(_pageId+" .sel_branch").text();  //上一次选中营业部的值
			$(_pageId+" .sel_branch").attr("branchcode",bid);	
			$(_pageId+" .sel_branch").text(branchname);	  //选中值赋给选择框
			// 天府二街营业部名称太长
			adjustBranchNameLayout(bid);
			appUtils.setSStorageInfo("branchname",branchname);
			$(_pageId+" .branch").slideUp("fast");	//隐藏下拉框
			e.stopPropagation();	// 阻止冒泡
		});	
	}
	
	function bindFixedBranch()
	{
		appUtils.bindEvent($(_pageId+" .branch ul li"),function(e){
			var bid = $(this).attr("bid");
			$(this).addClass("active").siblings().removeClass("active");
			branchParam.branchno = bid;
			var branchname = $(this).text();  //当前选中营业部的值
			var sel_bname = $(_pageId+" .sel_branch").text();  //上一次选中营业部的值
			$(_pageId+" .sel_branch").attr("branchcode",bid);	
			$(_pageId+" .sel_branch").text(branchname);	  //选中值赋给选择框
			// 天府二街营业部名称太长
			adjustBranchNameLayout(bid);
			appUtils.setSStorageInfo("branchname",branchname);
			$(_pageId+" .branch").slideUp("fast");	//隐藏下拉框
			if(sel_bname != branchname)	 
			{
				var cityno = "";
				var provincenno = "";
				var cityname = "";
				var provincename = "";
				var cityListLen = cityList.length;
				var branchListLen = branchList.length;
				var provinceListLen = provinceList.length; 
				
				for (var i = 0; i < branchListLen; i++) {
					if (bid == branchList[i].branchcode) {
						cityno = branchList[i].cityno;
						break;
					}
				}
				
				for (var i = 0; i < cityListLen; i++) {
					if (cityno == cityList[i].cityno) {
						provincenno = cityList[i].provincenno;
						cityname = cityList[i].cityname;
						break;
					}
				}
				for (var i = 0; i < provinceListLen; i++) {
					if (provincenno == provinceList[i].provinceno) {
						provincename = provinceList[i].provincename;
						break;
					}
				}
				
				$(_pageId+" .sel_city").text(cityname);
				appUtils.setSStorageInfo("cityname",cityname);
				
				$(_pageId+" .sel_province").text(provincename);
				appUtils.setSStorageInfo("provincename",provincename);
			}
			e.stopPropagation();	// 阻止冒泡
		});	
	}

	/**
	 * 检查联系人
	 */
	function checkBroker(writeInfo_referee){
		var param = {
				"user_id":appUtils.getSStorageInfo("user_id"),
				"brokercode":writeInfo_referee
		};
		//查询推荐人
		service.queryBrokerInfo(param,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == 0 ){
				var results = data.results;
				if(results!=null&&results.length>0) {
					var _branchno = results[0].dwbh;
					var index = branchIDList.indexOf(_branchno);
					if (-1 == index && branchNumber > 0) {
						$(_pageId+" #writeInfo_referee").val("");
						layerUtils.iAlert("您填写的经纪人不在指定的营业部内，请重新填写！");
						return;
					}
					var info = "推荐人姓名：" + results[0].ygxm + ",所在营业部：" + results[0].dwmc;
					isReferee = true;
					recommendname = results[0].ygxm;
					$("#sel_recommend").text(recommendname);
					layerUtils.iAlert(info);
					
					var branchid = results[0].dwbh;//营业部编号
					//根据推荐人 自动填充省市营业部
					autoFill(branchid, true);
				} else {
					layerUtils.iAlert("无此推荐人，请检查推荐人代码输入是否正确！");
				}
			} else {
				layerUtils.iAlert("无此推荐人，请检查推荐人代码输入是否正确！");
			}
		});
	}

	/* 根据推荐人 自动填充省市营业部*/
	function autoFill(branchid, isTip){
		if (branchid=='0' || branchid.length<=2) return;
		var cid = "";
		var pid = "";
		for(var i=0; i<branchList.length; i++){
			if(branchid == branchList[i].branchcode){
				cid = branchList[i].cityno;
				branchParam.branchno = branchList[i].branchcode;
				$(_pageId+" .sel_branch").attr("branchcode",branchList[i].branchcode);	
				$(_pageId+" .sel_branch").text(branchList[i].branchname);	  //选中值赋给选择框
				// 天府二街营业部名称太长
				adjustBranchNameLayout(branchid);
				appUtils.setSStorageInfo("branchname",branchList[i].branchname);
			}
		}
		for(var i=0; i<cityList.length; i++) 	{
			if(cid == cityList[i].cityno){
				pid = cityList[i].provincenno;
				$(_pageId+" .sel_city").text(cityList[i].cityname);	  //选中值赋给选择框
				appUtils.setSStorageInfo("cityname",cityList[i].cityname);
			}
		}
		for(var i=0; i<provinceList.length; i++) 	{
			if(pid == provinceList[i].provinceno){
				$(_pageId+" .sel_province").text(provinceList[i].provincename);	  //将选中值赋给选择框
				appUtils.setSStorageInfo("provincename",provinceList[i].provincename);
			}
		}

		if (branchNumber == 1) {
			$(_pageId+" .sel_province").removeClass("sel_text").addClass("sel_text_fixed");
			$(_pageId+" .sel_city").removeClass("sel_text").addClass("sel_text_fixed");
			$(_pageId+" .sel_branch").removeClass("sel_text").addClass("sel_text_fixed");
			return;
		} else if (branchNumber > 1) {
			appUtils.bindEvent($(_pageId+" .mobile_form .sel_province"),function(e){
				layerUtils.iAlert("已选择推荐人，不能更改省份！如需重新选择，请删除推荐人！");
			});
			appUtils.bindEvent($(_pageId+" .mobile_form .sel_city"),function(e){
				layerUtils.iAlert("已选择推荐人，不能更改城市！如需重新选择，请删除推荐人！");
			});
			appUtils.bindEvent($(_pageId+" .mobile_form .sel_branch"),function(e){
				layerUtils.iAlert("已选择推荐人，不能更改营业部！如需重新选择，请删除推荐人！");
			});
			return;
		}
		
		var city_str = "";
		//选中省份立即填充相应城市
		for(var i=0; i<cityList.length; i++)
		{
			var provincenno = cityList[i].provincenno;
			var cityno = cityList[i].cityno;
			var cityname = cityList[i].cityname;
			if(pid == provincenno)  //填充当前省份下的城市列表
			{
				city_str+= "<li cid='"+cityno+"'><span>"+cityname+"</span></li>";
			}
		}
		$(_pageId+" .city ul").html(city_str);  //填充城市下拉框
		
		var branch_str = "";
		for(var i=0; i<branchList.length; i++)
		{
			var cityno = branchList[i].cityno;
			var branchcode = branchList[i].branchcode;
			var branchname = branchList[i].branchname;
			if(cid == cityno)  //填充当前城市下的营业部列表
			{
				branch_str+= "<li bid='"+branchcode+"'><span>"+branchname+"</span></li>";
			}
		}
		$(_pageId+" .branch ul").html(branch_str);  //填充营业部下拉框
		bindBranch();
		bindCity(); 
		
		//取消省市营业部的点击事件css("backgroundColor","#F3F3F3");
		$(_pageId+" .mobile_form .sel_province").css("backgroundColor","#F3F3F3");
		$(_pageId+" .mobile_form .sel_city").css("backgroundColor","#F3F3F3");
		$(_pageId+" .mobile_form .sel_branch").css("backgroundColor","#F3F3F3");
		
		if (isTip) {
			appUtils.bindEvent($(_pageId+" .mobile_form .sel_province"),function(e){
				layerUtils.iAlert("已选择推荐人，不能更改省份！如需重新选择，请删除推荐人！");
			});
			appUtils.bindEvent($(_pageId+" .mobile_form .sel_city"),function(e){
				layerUtils.iAlert("已选择推荐人，不能更改城市！如需重新选择，请删除推荐人！");
			});
			appUtils.bindEvent($(_pageId+" .mobile_form .sel_branch"),function(e){
				layerUtils.iAlert("已选择推荐人，不能更改营业部！如需重新选择，请删除推荐人！");
			});
		}
	}
	
	//删除推荐人后 重新绑定选着省市营业部事件
	function reBind(){
		/* 绑定选择省份 */
		appUtils.bindEvent($(_pageId+" .mobile_form .sel_province"),function(e){
			$(_pageId+" .city").hide();  //隐藏城市列表
			$(_pageId+" .branch").hide();  //隐藏营业部列表
			$(_pageId+" .recommend").hide();  //隐藏推荐人列表
			$(_pageId+" .province ul li").removeClass("active");
			$(_pageId+" .province").slideToggle("fast");	 // 显示选择省份的下拉列表
			e.stopPropagation();	// 阻止冒泡
		});
		/* 绑定选择城市 */
		appUtils.bindEvent($(_pageId+" .mobile_form .sel_city"),function(e){
			$(_pageId+" .province").hide();  //隐藏省份列表
			$(_pageId+" .branch").hide();  //隐藏营业部列表
			$(_pageId+" .recommend").hide();  //隐藏推荐人列表
			$(_pageId+" .city ul li").removeClass("active");
			$(_pageId+" .city").slideToggle("fast");	// 显示选择城市的下拉列表
			e.stopPropagation();	// 阻止冒泡
		});
		/* 绑定选择营业部 */
		appUtils.bindEvent($(_pageId+" .mobile_form .sel_branch"),function(e){
			$(_pageId+" .province").hide();  //隐藏省份列表
			$(_pageId+" .city").hide();  //隐藏城市列表
			$(_pageId+" .recommend").hide();  //隐藏推荐人列表
			$(_pageId+" .branch ul li").removeClass("active");
			$(_pageId+" .branch").slideToggle("fast");	// 显示选择营业厅的下拉列表
			e.stopPropagation();	// 阻止冒泡
		});
		$(_pageId+" .mobile_form .sel_province").css("backgroundColor","#FFFFFF");
		$(_pageId+" .mobile_form .sel_city").css("backgroundColor","#FFFFFF");
		$(_pageId+" .mobile_form .sel_branch").css("backgroundColor","#FFFFFF");
		
	}
	
	//获取本地存储的推荐人信息
	function getLocalRecommend(){
		require("shellPlugin").callShellMethod("sharePrefencePilugin",function(data){
			if(data.recommendno){
				var recommendno = data.recommendno;
				var param = {
						"user_id":appUtils.getSStorageInfo("user_id"),
						"brokercode":recommendno
				};
				//查询推荐人
				service.queryBrokerInfo(param,function(data){
					var error_no = data.error_no;
					if(error_no == 0 ){
						var results = data.results;
						if(results!=null&&results.length>0) {
							var _branchno = results[0].dwbh;
							isReferee = true;
							recommendname = results[0].ygxm;
							$(_pageId+" #writeInfo_referee").val(recommendno);
							$("#sel_recommend").text(recommendname);
							var branchid = results[0].dwbh;//营业部编号
							//根据推荐人 自动填充省市营业部
							autoFill(branchid);
						} else {
//							layerUtils.iAlert("无此推荐人，请检查推荐人代码输入是否正确！");
						}
					} else {
//						layerUtils.iAlert("无此推荐人，请检查推荐人代码输入是否正确！");
					}
				});
				
			}
		},null,{"states":"1"});
		
	}
	
	//设置本地存储的推荐人信息
	function setLocalRecommend(recommendno){
		require("shellPlugin").callShellMethod("sharePrefencePilugin",null,null,{"states":"0","recommendno":recommendno});
		
	}

	// 调整营业部名称显示控件布局
	function adjustBranchNameLayout(bid) {
		// 天府二街营业部名称太长
		if (bid == "7320") {
			$(_pageId+" .sel_branch").css("padding-right", "0px");
		}
	}

	/* 清理界面元素 */
	function cleanPageElement()
	{
		hasbranch = false;
		$(_pageId+" .header .icon_back").hide(); //隐藏返回按钮
		$(_pageId+" .sel_province").text("请选择省份");
		$(_pageId+" .sel_city").text("请选择城市");
		$(_pageId+" .sel_branch").text("请选择营业部");
		$(_pageId+" .sel_commssion").text("请选择佣金套餐");
	}
	var selDepartment = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};

	// 暴露对外的接口
	module.exports = selDepartment;
});