/**
* 查看协议
*/
define("project/scripts/account/tips",function(require, exports, module){ 
	var appUtils = require("appUtils"),
		global = require("gconfig").global,
		service = require("serviceImp").getInstance(),  //业务层接口，请求数据
		layerUtils = require("layerUtils"),
		_pageId = "#account_tips";
	
	function init(){
		var risk_prompt = appUtils.getPageParam("risk_prompt");
		$(_pageId+" #contenttxt").html(risk_prompt);
	}

	function bindPageEvent(){
		
		// 绑定继续开户
		appUtils.bindEvent($(_pageId+" #submit"),function(){
			checkRiskLevel();
		});
		
		appUtils.bindEvent($(_pageId+" .icon_back"),function(){
			appUtils.pageBack();
		});
	}
	
	function checkRiskLevel(){
		var param = {
			"user_id":appUtils.getSStorageInfo("user_id"),
			"product_level":"1",
			"risk_level":appUtils.getSStorageInfo("riskexp"),
			"riskmatching":appUtils.getSStorageInfo("riskmatching")
		}
		service.req502039(param,function(data){
			var errorNo = data.error_no;
			var errorInfo = data.error_info;
			if(errorNo==0)	 // 调用成功,跳转到风险测评页面 50195504问卷已激活，也是跳到下一步
			{
				appUtils.pageInit("account/tips","account/accountResult",{});
			}
			else
			{
				layerUtils.iAlert(errorInfo, -1);
			}
		});
	}
	
	function destroy(){
		$(_pageId+" #contenttxt").html("");
		service.destroy();
	}
	
	var tips = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	module.exports = tips;
});